/* Emacs style mode select   -*- C++ -*-
 *-----------------------------------------------------------------------------
 *
 *
 *  PrBoom: a Doom port merged with LxDoom and LSDLDoom
 *  based on BOOM, a modified and improved DOOM engine
 *  Copyright (C) 1999 by
 *  id Software, Chi Hoang, Lee Killough, Jim Flynn, Rand Phares, Ty Halderman
 *  Copyright (C) 1999-2000 by
 *  Jess Haas, Nicolas Kalkhof, Colin Phipps, Florian Schulze
 *  Copyright 2005, 2006 by
 *  Florian Schulze, Colin Phipps, Neil Stevens, Andrey Budko
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 *  02111-1307, USA.
 *
 * DESCRIPTION:
 *      Thing frame/state LUT,
 *      generated by multigen utilitiy.
 *      This one is the original DOOM version, preserved.
 *
 *-----------------------------------------------------------------------------*/

#ifndef __INFO__
#define __INFO__

/* Needed for action function pointer handling. */
#include "d_think.h"
#include "doomtype.h"

#include "dsda/global.h"

#define MAXSTATEARGS 8

/********************************************************************
 * Sprite name enumeration - must match info.c                      *
 ********************************************************************/
typedef enum
{
  SPR_TROO,
  SPR_SHTG,
  SPR_PUNG,
  SPR_PISG,
  SPR_PISF,
  SPR_SHTF,
  SPR_SHT2,
  SPR_CHGG,
  SPR_CHGF,
  SPR_MISG,
  SPR_MISF,
  SPR_SAWG,
  SPR_PLSG,
  SPR_PLSF,
  SPR_BFGG,
  SPR_BFGF,
  SPR_BLUD,
  SPR_PUFF,
  SPR_BAL1,
  SPR_BAL2,
  SPR_PLSS,
  SPR_PLSE,
  SPR_MISL,
  SPR_BFS1,
  SPR_BFE1,
  SPR_BFE2,
  SPR_TFOG,
  SPR_IFOG,
  SPR_PLAY,
  SPR_POSS,
  SPR_SPOS,
  SPR_VILE,
  SPR_FIRE,
  SPR_FATB,
  SPR_FBXP,
  SPR_SKEL,
  SPR_MANF,
  SPR_FATT,
  SPR_CPOS,
  SPR_SARG,
  SPR_HEAD,
  SPR_BAL7,
  SPR_BOSS,
  SPR_BOS2,
  SPR_SKUL,
  SPR_SPID,
  SPR_BSPI,
  SPR_APLS,
  SPR_APBX,
  SPR_CYBR,
  SPR_PAIN,
  SPR_SSWV,
  SPR_KEEN,
  SPR_BBRN,
  SPR_BOSF,
  SPR_ARM1,
  SPR_ARM2,
  SPR_BAR1,
  SPR_BEXP,
  SPR_FCAN,
  SPR_BON1,
  SPR_BON2,
  SPR_BKEY,
  SPR_RKEY,
  SPR_YKEY,
  SPR_BSKU,
  SPR_RSKU,
  SPR_YSKU,
  SPR_STIM,
  SPR_MEDI,
  SPR_SOUL,
  SPR_PINV,
  SPR_PSTR,
  SPR_PINS,
  SPR_MEGA,
  SPR_SUIT,
  SPR_PMAP,
  SPR_PVIS,
  SPR_CLIP,
  SPR_AMMO,
  SPR_ROCK,
  SPR_BROK,
  SPR_CELL,
  SPR_CELP,
  SPR_SHEL,
  SPR_SBOX,
  SPR_BPAK,
  SPR_BFUG,
  SPR_MGUN,
  SPR_CSAW,
  SPR_LAUN,
  SPR_PLAS,
  SPR_SHOT,
  SPR_SGN2,
  SPR_COLU,
  SPR_SMT2,
  SPR_GOR1,
  SPR_POL2,
  SPR_POL5,
  SPR_POL4,
  SPR_POL3,
  SPR_POL1,
  SPR_POL6,
  SPR_GOR2,
  SPR_GOR3,
  SPR_GOR4,
  SPR_GOR5,
  SPR_SMIT,
  SPR_COL1,
  SPR_COL2,
  SPR_COL3,
  SPR_COL4,
  SPR_CAND,
  SPR_CBRA,
  SPR_COL6,
  SPR_TRE1,
  SPR_TRE2,
  SPR_ELEC,
  SPR_CEYE,
  SPR_FSKU,
  SPR_COL5,
  SPR_TBLU,
  SPR_TGRN,
  SPR_TRED,
  SPR_SMBT,
  SPR_SMGT,
  SPR_SMRT,
  SPR_HDB1,
  SPR_HDB2,
  SPR_HDB3,
  SPR_HDB4,
  SPR_HDB5,
  SPR_HDB6,
  SPR_POB1,
  SPR_POB2,
  SPR_BRS1,
  SPR_TLMP,
  SPR_TLP2,
  SPR_TNT1, /* add invisible sprite              phares 3/8/98 */
  SPR_DOGS, /* killough 7/19/98: Marine's best friend :) */
  SPR_PLS1, // killough 7/19/98: first  of two plasma fireballs in the beta
  SPR_PLS2, // killough 7/19/98: second of two plasma fireballs in the beta
  SPR_BON3, // killough 7/11/98: evil sceptre in beta version
  SPR_BON4, // killough 7/11/98: unholy bible in beta version
  SPR_BLD2, // blood splats from Doom Retro, unsused in PrBoom+

  // 100 extra sprite names to use in dehacked patches
  SPR_SP00, SPR_SP01, SPR_SP02, SPR_SP03, SPR_SP04, SPR_SP05, SPR_SP06, SPR_SP07, SPR_SP08, SPR_SP09,
  SPR_SP10, SPR_SP11, SPR_SP12, SPR_SP13, SPR_SP14, SPR_SP15, SPR_SP16, SPR_SP17, SPR_SP18, SPR_SP19,
  SPR_SP20, SPR_SP21, SPR_SP22, SPR_SP23, SPR_SP24, SPR_SP25, SPR_SP26, SPR_SP27, SPR_SP28, SPR_SP29,
  SPR_SP30, SPR_SP31, SPR_SP32, SPR_SP33, SPR_SP34, SPR_SP35, SPR_SP36, SPR_SP37, SPR_SP38, SPR_SP39,
  SPR_SP40, SPR_SP41, SPR_SP42, SPR_SP43, SPR_SP44, SPR_SP45, SPR_SP46, SPR_SP47, SPR_SP48, SPR_SP49,
  SPR_SP50, SPR_SP51, SPR_SP52, SPR_SP53, SPR_SP54, SPR_SP55, SPR_SP56, SPR_SP57, SPR_SP58, SPR_SP59,
  SPR_SP60, SPR_SP61, SPR_SP62, SPR_SP63, SPR_SP64, SPR_SP65, SPR_SP66, SPR_SP67, SPR_SP68, SPR_SP69,
  SPR_SP70, SPR_SP71, SPR_SP72, SPR_SP73, SPR_SP74, SPR_SP75, SPR_SP76, SPR_SP77, SPR_SP78, SPR_SP79,
  SPR_SP80, SPR_SP81, SPR_SP82, SPR_SP83, SPR_SP84, SPR_SP85, SPR_SP86, SPR_SP87, SPR_SP88, SPR_SP89,
  SPR_SP90, SPR_SP91, SPR_SP92, SPR_SP93, SPR_SP94, SPR_SP95, SPR_SP96, SPR_SP97, SPR_SP98, SPR_SP99,

  NUMSPRITES,  /* counter of how many there are */

  // heretic
  HERETIC_SPR_IMPX = 0,
  HERETIC_SPR_ACLO,
  HERETIC_SPR_PTN1,
  HERETIC_SPR_SHLD,
  HERETIC_SPR_SHD2,
  HERETIC_SPR_BAGH,
  HERETIC_SPR_SPMP,
  HERETIC_SPR_INVS,
  HERETIC_SPR_PTN2,
  HERETIC_SPR_SOAR,
  HERETIC_SPR_INVU,
  HERETIC_SPR_PWBK,
  HERETIC_SPR_EGGC,
  HERETIC_SPR_EGGM,
  HERETIC_SPR_FX01,
  HERETIC_SPR_SPHL,
  HERETIC_SPR_TRCH,
  HERETIC_SPR_FBMB,
  HERETIC_SPR_XPL1,
  HERETIC_SPR_ATLP,
  HERETIC_SPR_PPOD,
  HERETIC_SPR_AMG1,
  HERETIC_SPR_SPSH,
  HERETIC_SPR_LVAS,
  HERETIC_SPR_SLDG,
  HERETIC_SPR_SKH1,
  HERETIC_SPR_SKH2,
  HERETIC_SPR_SKH3,
  HERETIC_SPR_SKH4,
  HERETIC_SPR_CHDL,
  HERETIC_SPR_SRTC,
  HERETIC_SPR_SMPL,
  HERETIC_SPR_STGS,
  HERETIC_SPR_STGL,
  HERETIC_SPR_STCS,
  HERETIC_SPR_STCL,
  HERETIC_SPR_KFR1,
  HERETIC_SPR_BARL,
  HERETIC_SPR_BRPL,
  HERETIC_SPR_MOS1,
  HERETIC_SPR_MOS2,
  HERETIC_SPR_WTRH,
  HERETIC_SPR_HCOR,
  HERETIC_SPR_KGZ1,
  HERETIC_SPR_KGZB,
  HERETIC_SPR_KGZG,
  HERETIC_SPR_KGZY,
  HERETIC_SPR_VLCO,
  HERETIC_SPR_VFBL,
  HERETIC_SPR_VTFB,
  HERETIC_SPR_SFFI,
  HERETIC_SPR_TGLT,
  HERETIC_SPR_TELE,
  HERETIC_SPR_STFF,
  HERETIC_SPR_PUF3,
  HERETIC_SPR_PUF4,
  HERETIC_SPR_BEAK,
  HERETIC_SPR_WGNT,
  HERETIC_SPR_GAUN,
  HERETIC_SPR_PUF1,
  HERETIC_SPR_WBLS,
  HERETIC_SPR_BLSR,
  HERETIC_SPR_FX18,
  HERETIC_SPR_FX17,
  HERETIC_SPR_WMCE,
  HERETIC_SPR_MACE,
  HERETIC_SPR_FX02,
  HERETIC_SPR_WSKL,
  HERETIC_SPR_HROD,
  HERETIC_SPR_FX00,
  HERETIC_SPR_FX20,
  HERETIC_SPR_FX21,
  HERETIC_SPR_FX22,
  HERETIC_SPR_FX23,
  HERETIC_SPR_GWND,
  HERETIC_SPR_PUF2,
  HERETIC_SPR_WPHX,
  HERETIC_SPR_PHNX,
  HERETIC_SPR_FX04,
  HERETIC_SPR_FX08,
  HERETIC_SPR_FX09,
  HERETIC_SPR_WBOW,
  HERETIC_SPR_CRBW,
  HERETIC_SPR_FX03,
  HERETIC_SPR_BLOD,
  HERETIC_SPR_PLAY,
  HERETIC_SPR_FDTH,
  HERETIC_SPR_BSKL,
  HERETIC_SPR_CHKN,
  HERETIC_SPR_MUMM,
  HERETIC_SPR_FX15,
  HERETIC_SPR_BEAS,
  HERETIC_SPR_FRB1,
  HERETIC_SPR_SNKE,
  HERETIC_SPR_SNFX,
  HERETIC_SPR_HEAD,
  HERETIC_SPR_FX05,
  HERETIC_SPR_FX06,
  HERETIC_SPR_FX07,
  HERETIC_SPR_CLNK,
  HERETIC_SPR_WZRD,
  HERETIC_SPR_FX11,
  HERETIC_SPR_FX10,
  HERETIC_SPR_KNIG,
  HERETIC_SPR_SPAX,
  HERETIC_SPR_RAXE,
  HERETIC_SPR_SRCR,
  HERETIC_SPR_FX14,
  HERETIC_SPR_SOR2,
  HERETIC_SPR_SDTH,
  HERETIC_SPR_FX16,
  HERETIC_SPR_MNTR,
  HERETIC_SPR_FX12,
  HERETIC_SPR_FX13,
  HERETIC_SPR_AKYY,
  HERETIC_SPR_BKYY,
  HERETIC_SPR_CKYY,
  HERETIC_SPR_AMG2,
  HERETIC_SPR_AMM1,
  HERETIC_SPR_AMM2,
  HERETIC_SPR_AMC1,
  HERETIC_SPR_AMC2,
  HERETIC_SPR_AMS1,
  HERETIC_SPR_AMS2,
  HERETIC_SPR_AMP1,
  HERETIC_SPR_AMP2,
  HERETIC_SPR_AMB1,
  HERETIC_SPR_AMB2,
  HERETIC_NUMSPRITES
} spritenum_t;

/********************************************************************
 * States (frames) enumeration -- must match info.c                 *
 ********************************************************************/

typedef enum
{
  S_NULL,
  S_LIGHTDONE,
  S_PUNCH,
  S_PUNCHDOWN,
  S_PUNCHUP,
  S_PUNCH1,
  S_PUNCH2,
  S_PUNCH3,
  S_PUNCH4,
  S_PUNCH5,
  S_PISTOL,
  S_PISTOLDOWN,
  S_PISTOLUP,
  S_PISTOL1,
  S_PISTOL2,
  S_PISTOL3,
  S_PISTOL4,
  S_PISTOLFLASH,
  S_SGUN,
  S_SGUNDOWN,
  S_SGUNUP,
  S_SGUN1,
  S_SGUN2,
  S_SGUN3,
  S_SGUN4,
  S_SGUN5,
  S_SGUN6,
  S_SGUN7,
  S_SGUN8,
  S_SGUN9,
  S_SGUNFLASH1,
  S_SGUNFLASH2,
  S_DSGUN,
  S_DSGUNDOWN,
  S_DSGUNUP,
  S_DSGUN1,
  S_DSGUN2,
  S_DSGUN3,
  S_DSGUN4,
  S_DSGUN5,
  S_DSGUN6,
  S_DSGUN7,
  S_DSGUN8,
  S_DSGUN9,
  S_DSGUN10,
  S_DSNR1,
  S_DSNR2,
  S_DSGUNFLASH1,
  S_DSGUNFLASH2,
  S_CHAIN,
  S_CHAINDOWN,
  S_CHAINUP,
  S_CHAIN1,
  S_CHAIN2,
  S_CHAIN3,
  S_CHAINFLASH1,
  S_CHAINFLASH2,
  S_MISSILE,
  S_MISSILEDOWN,
  S_MISSILEUP,
  S_MISSILE1,
  S_MISSILE2,
  S_MISSILE3,
  S_MISSILEFLASH1,
  S_MISSILEFLASH2,
  S_MISSILEFLASH3,
  S_MISSILEFLASH4,
  S_SAW,
  S_SAWB,
  S_SAWDOWN,
  S_SAWUP,
  S_SAW1,
  S_SAW2,
  S_SAW3,
  S_PLASMA,
  S_PLASMADOWN,
  S_PLASMAUP,
  S_PLASMA1,
  S_PLASMA2,
  S_PLASMAFLASH1,
  S_PLASMAFLASH2,
  S_BFG,
  S_BFGDOWN,
  S_BFGUP,
  S_BFG1,
  S_BFG2,
  S_BFG3,
  S_BFG4,
  S_BFGFLASH1,
  S_BFGFLASH2,
  S_BLOOD1,
  S_BLOOD2,
  S_BLOOD3,
  S_PUFF1,
  S_PUFF2,
  S_PUFF3,
  S_PUFF4,
  S_TBALL1,
  S_TBALL2,
  S_TBALLX1,
  S_TBALLX2,
  S_TBALLX3,
  S_RBALL1,
  S_RBALL2,
  S_RBALLX1,
  S_RBALLX2,
  S_RBALLX3,
  S_PLASBALL,
  S_PLASBALL2,
  S_PLASEXP,
  S_PLASEXP2,
  S_PLASEXP3,
  S_PLASEXP4,
  S_PLASEXP5,
  S_ROCKET,
  S_BFGSHOT,
  S_BFGSHOT2,
  S_BFGLAND,
  S_BFGLAND2,
  S_BFGLAND3,
  S_BFGLAND4,
  S_BFGLAND5,
  S_BFGLAND6,
  S_BFGEXP,
  S_BFGEXP2,
  S_BFGEXP3,
  S_BFGEXP4,
  S_EXPLODE1,
  S_EXPLODE2,
  S_EXPLODE3,
  S_TFOG,
  S_TFOG01,
  S_TFOG02,
  S_TFOG2,
  S_TFOG3,
  S_TFOG4,
  S_TFOG5,
  S_TFOG6,
  S_TFOG7,
  S_TFOG8,
  S_TFOG9,
  S_TFOG10,
  S_IFOG,
  S_IFOG01,
  S_IFOG02,
  S_IFOG2,
  S_IFOG3,
  S_IFOG4,
  S_IFOG5,
  S_PLAY,
  S_PLAY_RUN1,
  S_PLAY_RUN2,
  S_PLAY_RUN3,
  S_PLAY_RUN4,
  S_PLAY_ATK1,
  S_PLAY_ATK2,
  S_PLAY_PAIN,
  S_PLAY_PAIN2,
  S_PLAY_DIE1,
  S_PLAY_DIE2,
  S_PLAY_DIE3,
  S_PLAY_DIE4,
  S_PLAY_DIE5,
  S_PLAY_DIE6,
  S_PLAY_DIE7,
  S_PLAY_XDIE1,
  S_PLAY_XDIE2,
  S_PLAY_XDIE3,
  S_PLAY_XDIE4,
  S_PLAY_XDIE5,
  S_PLAY_XDIE6,
  S_PLAY_XDIE7,
  S_PLAY_XDIE8,
  S_PLAY_XDIE9,
  S_POSS_STND,
  S_POSS_STND2,
  S_POSS_RUN1,
  S_POSS_RUN2,
  S_POSS_RUN3,
  S_POSS_RUN4,
  S_POSS_RUN5,
  S_POSS_RUN6,
  S_POSS_RUN7,
  S_POSS_RUN8,
  S_POSS_ATK1,
  S_POSS_ATK2,
  S_POSS_ATK3,
  S_POSS_PAIN,
  S_POSS_PAIN2,
  S_POSS_DIE1,
  S_POSS_DIE2,
  S_POSS_DIE3,
  S_POSS_DIE4,
  S_POSS_DIE5,
  S_POSS_XDIE1,
  S_POSS_XDIE2,
  S_POSS_XDIE3,
  S_POSS_XDIE4,
  S_POSS_XDIE5,
  S_POSS_XDIE6,
  S_POSS_XDIE7,
  S_POSS_XDIE8,
  S_POSS_XDIE9,
  S_POSS_RAISE1,
  S_POSS_RAISE2,
  S_POSS_RAISE3,
  S_POSS_RAISE4,
  S_SPOS_STND,
  S_SPOS_STND2,
  S_SPOS_RUN1,
  S_SPOS_RUN2,
  S_SPOS_RUN3,
  S_SPOS_RUN4,
  S_SPOS_RUN5,
  S_SPOS_RUN6,
  S_SPOS_RUN7,
  S_SPOS_RUN8,
  S_SPOS_ATK1,
  S_SPOS_ATK2,
  S_SPOS_ATK3,
  S_SPOS_PAIN,
  S_SPOS_PAIN2,
  S_SPOS_DIE1,
  S_SPOS_DIE2,
  S_SPOS_DIE3,
  S_SPOS_DIE4,
  S_SPOS_DIE5,
  S_SPOS_XDIE1,
  S_SPOS_XDIE2,
  S_SPOS_XDIE3,
  S_SPOS_XDIE4,
  S_SPOS_XDIE5,
  S_SPOS_XDIE6,
  S_SPOS_XDIE7,
  S_SPOS_XDIE8,
  S_SPOS_XDIE9,
  S_SPOS_RAISE1,
  S_SPOS_RAISE2,
  S_SPOS_RAISE3,
  S_SPOS_RAISE4,
  S_SPOS_RAISE5,
  S_VILE_STND,
  S_VILE_STND2,
  S_VILE_RUN1,
  S_VILE_RUN2,
  S_VILE_RUN3,
  S_VILE_RUN4,
  S_VILE_RUN5,
  S_VILE_RUN6,
  S_VILE_RUN7,
  S_VILE_RUN8,
  S_VILE_RUN9,
  S_VILE_RUN10,
  S_VILE_RUN11,
  S_VILE_RUN12,
  S_VILE_ATK1,
  S_VILE_ATK2,
  S_VILE_ATK3,
  S_VILE_ATK4,
  S_VILE_ATK5,
  S_VILE_ATK6,
  S_VILE_ATK7,
  S_VILE_ATK8,
  S_VILE_ATK9,
  S_VILE_ATK10,
  S_VILE_ATK11,
  S_VILE_HEAL1,
  S_VILE_HEAL2,
  S_VILE_HEAL3,
  S_VILE_PAIN,
  S_VILE_PAIN2,
  S_VILE_DIE1,
  S_VILE_DIE2,
  S_VILE_DIE3,
  S_VILE_DIE4,
  S_VILE_DIE5,
  S_VILE_DIE6,
  S_VILE_DIE7,
  S_VILE_DIE8,
  S_VILE_DIE9,
  S_VILE_DIE10,
  S_FIRE1,
  S_FIRE2,
  S_FIRE3,
  S_FIRE4,
  S_FIRE5,
  S_FIRE6,
  S_FIRE7,
  S_FIRE8,
  S_FIRE9,
  S_FIRE10,
  S_FIRE11,
  S_FIRE12,
  S_FIRE13,
  S_FIRE14,
  S_FIRE15,
  S_FIRE16,
  S_FIRE17,
  S_FIRE18,
  S_FIRE19,
  S_FIRE20,
  S_FIRE21,
  S_FIRE22,
  S_FIRE23,
  S_FIRE24,
  S_FIRE25,
  S_FIRE26,
  S_FIRE27,
  S_FIRE28,
  S_FIRE29,
  S_FIRE30,
  S_SMOKE1,
  S_SMOKE2,
  S_SMOKE3,
  S_SMOKE4,
  S_SMOKE5,
  S_TRACER,
  S_TRACER2,
  S_TRACEEXP1,
  S_TRACEEXP2,
  S_TRACEEXP3,
  S_SKEL_STND,
  S_SKEL_STND2,
  S_SKEL_RUN1,
  S_SKEL_RUN2,
  S_SKEL_RUN3,
  S_SKEL_RUN4,
  S_SKEL_RUN5,
  S_SKEL_RUN6,
  S_SKEL_RUN7,
  S_SKEL_RUN8,
  S_SKEL_RUN9,
  S_SKEL_RUN10,
  S_SKEL_RUN11,
  S_SKEL_RUN12,
  S_SKEL_FIST1,
  S_SKEL_FIST2,
  S_SKEL_FIST3,
  S_SKEL_FIST4,
  S_SKEL_MISS1,
  S_SKEL_MISS2,
  S_SKEL_MISS3,
  S_SKEL_MISS4,
  S_SKEL_PAIN,
  S_SKEL_PAIN2,
  S_SKEL_DIE1,
  S_SKEL_DIE2,
  S_SKEL_DIE3,
  S_SKEL_DIE4,
  S_SKEL_DIE5,
  S_SKEL_DIE6,
  S_SKEL_RAISE1,
  S_SKEL_RAISE2,
  S_SKEL_RAISE3,
  S_SKEL_RAISE4,
  S_SKEL_RAISE5,
  S_SKEL_RAISE6,
  S_FATSHOT1,
  S_FATSHOT2,
  S_FATSHOTX1,
  S_FATSHOTX2,
  S_FATSHOTX3,
  S_FATT_STND,
  S_FATT_STND2,
  S_FATT_RUN1,
  S_FATT_RUN2,
  S_FATT_RUN3,
  S_FATT_RUN4,
  S_FATT_RUN5,
  S_FATT_RUN6,
  S_FATT_RUN7,
  S_FATT_RUN8,
  S_FATT_RUN9,
  S_FATT_RUN10,
  S_FATT_RUN11,
  S_FATT_RUN12,
  S_FATT_ATK1,
  S_FATT_ATK2,
  S_FATT_ATK3,
  S_FATT_ATK4,
  S_FATT_ATK5,
  S_FATT_ATK6,
  S_FATT_ATK7,
  S_FATT_ATK8,
  S_FATT_ATK9,
  S_FATT_ATK10,
  S_FATT_PAIN,
  S_FATT_PAIN2,
  S_FATT_DIE1,
  S_FATT_DIE2,
  S_FATT_DIE3,
  S_FATT_DIE4,
  S_FATT_DIE5,
  S_FATT_DIE6,
  S_FATT_DIE7,
  S_FATT_DIE8,
  S_FATT_DIE9,
  S_FATT_DIE10,
  S_FATT_RAISE1,
  S_FATT_RAISE2,
  S_FATT_RAISE3,
  S_FATT_RAISE4,
  S_FATT_RAISE5,
  S_FATT_RAISE6,
  S_FATT_RAISE7,
  S_FATT_RAISE8,
  S_CPOS_STND,
  S_CPOS_STND2,
  S_CPOS_RUN1,
  S_CPOS_RUN2,
  S_CPOS_RUN3,
  S_CPOS_RUN4,
  S_CPOS_RUN5,
  S_CPOS_RUN6,
  S_CPOS_RUN7,
  S_CPOS_RUN8,
  S_CPOS_ATK1,
  S_CPOS_ATK2,
  S_CPOS_ATK3,
  S_CPOS_ATK4,
  S_CPOS_PAIN,
  S_CPOS_PAIN2,
  S_CPOS_DIE1,
  S_CPOS_DIE2,
  S_CPOS_DIE3,
  S_CPOS_DIE4,
  S_CPOS_DIE5,
  S_CPOS_DIE6,
  S_CPOS_DIE7,
  S_CPOS_XDIE1,
  S_CPOS_XDIE2,
  S_CPOS_XDIE3,
  S_CPOS_XDIE4,
  S_CPOS_XDIE5,
  S_CPOS_XDIE6,
  S_CPOS_RAISE1,
  S_CPOS_RAISE2,
  S_CPOS_RAISE3,
  S_CPOS_RAISE4,
  S_CPOS_RAISE5,
  S_CPOS_RAISE6,
  S_CPOS_RAISE7,
  S_TROO_STND,
  S_TROO_STND2,
  S_TROO_RUN1,
  S_TROO_RUN2,
  S_TROO_RUN3,
  S_TROO_RUN4,
  S_TROO_RUN5,
  S_TROO_RUN6,
  S_TROO_RUN7,
  S_TROO_RUN8,
  S_TROO_ATK1,
  S_TROO_ATK2,
  S_TROO_ATK3,
  S_TROO_PAIN,
  S_TROO_PAIN2,
  S_TROO_DIE1,
  S_TROO_DIE2,
  S_TROO_DIE3,
  S_TROO_DIE4,
  S_TROO_DIE5,
  S_TROO_XDIE1,
  S_TROO_XDIE2,
  S_TROO_XDIE3,
  S_TROO_XDIE4,
  S_TROO_XDIE5,
  S_TROO_XDIE6,
  S_TROO_XDIE7,
  S_TROO_XDIE8,
  S_TROO_RAISE1,
  S_TROO_RAISE2,
  S_TROO_RAISE3,
  S_TROO_RAISE4,
  S_TROO_RAISE5,
  S_SARG_STND,
  S_SARG_STND2,
  S_SARG_RUN1,
  S_SARG_RUN2,
  S_SARG_RUN3,
  S_SARG_RUN4,
  S_SARG_RUN5,
  S_SARG_RUN6,
  S_SARG_RUN7,
  S_SARG_RUN8,
  S_SARG_ATK1,
  S_SARG_ATK2,
  S_SARG_ATK3,
  S_SARG_PAIN,
  S_SARG_PAIN2,
  S_SARG_DIE1,
  S_SARG_DIE2,
  S_SARG_DIE3,
  S_SARG_DIE4,
  S_SARG_DIE5,
  S_SARG_DIE6,
  S_SARG_RAISE1,
  S_SARG_RAISE2,
  S_SARG_RAISE3,
  S_SARG_RAISE4,
  S_SARG_RAISE5,
  S_SARG_RAISE6,
  S_HEAD_STND,
  S_HEAD_RUN1,
  S_HEAD_ATK1,
  S_HEAD_ATK2,
  S_HEAD_ATK3,
  S_HEAD_PAIN,
  S_HEAD_PAIN2,
  S_HEAD_PAIN3,
  S_HEAD_DIE1,
  S_HEAD_DIE2,
  S_HEAD_DIE3,
  S_HEAD_DIE4,
  S_HEAD_DIE5,
  S_HEAD_DIE6,
  S_HEAD_RAISE1,
  S_HEAD_RAISE2,
  S_HEAD_RAISE3,
  S_HEAD_RAISE4,
  S_HEAD_RAISE5,
  S_HEAD_RAISE6,
  S_BRBALL1,
  S_BRBALL2,
  S_BRBALLX1,
  S_BRBALLX2,
  S_BRBALLX3,
  S_BOSS_STND,
  S_BOSS_STND2,
  S_BOSS_RUN1,
  S_BOSS_RUN2,
  S_BOSS_RUN3,
  S_BOSS_RUN4,
  S_BOSS_RUN5,
  S_BOSS_RUN6,
  S_BOSS_RUN7,
  S_BOSS_RUN8,
  S_BOSS_ATK1,
  S_BOSS_ATK2,
  S_BOSS_ATK3,
  S_BOSS_PAIN,
  S_BOSS_PAIN2,
  S_BOSS_DIE1,
  S_BOSS_DIE2,
  S_BOSS_DIE3,
  S_BOSS_DIE4,
  S_BOSS_DIE5,
  S_BOSS_DIE6,
  S_BOSS_DIE7,
  S_BOSS_RAISE1,
  S_BOSS_RAISE2,
  S_BOSS_RAISE3,
  S_BOSS_RAISE4,
  S_BOSS_RAISE5,
  S_BOSS_RAISE6,
  S_BOSS_RAISE7,
  S_BOS2_STND,
  S_BOS2_STND2,
  S_BOS2_RUN1,
  S_BOS2_RUN2,
  S_BOS2_RUN3,
  S_BOS2_RUN4,
  S_BOS2_RUN5,
  S_BOS2_RUN6,
  S_BOS2_RUN7,
  S_BOS2_RUN8,
  S_BOS2_ATK1,
  S_BOS2_ATK2,
  S_BOS2_ATK3,
  S_BOS2_PAIN,
  S_BOS2_PAIN2,
  S_BOS2_DIE1,
  S_BOS2_DIE2,
  S_BOS2_DIE3,
  S_BOS2_DIE4,
  S_BOS2_DIE5,
  S_BOS2_DIE6,
  S_BOS2_DIE7,
  S_BOS2_RAISE1,
  S_BOS2_RAISE2,
  S_BOS2_RAISE3,
  S_BOS2_RAISE4,
  S_BOS2_RAISE5,
  S_BOS2_RAISE6,
  S_BOS2_RAISE7,
  S_SKULL_STND,
  S_SKULL_STND2,
  S_SKULL_RUN1,
  S_SKULL_RUN2,
  S_SKULL_ATK1,
  S_SKULL_ATK2,
  S_SKULL_ATK3,
  S_SKULL_ATK4,
  S_SKULL_PAIN,
  S_SKULL_PAIN2,
  S_SKULL_DIE1,
  S_SKULL_DIE2,
  S_SKULL_DIE3,
  S_SKULL_DIE4,
  S_SKULL_DIE5,
  S_SKULL_DIE6,
  S_SPID_STND,
  S_SPID_STND2,
  S_SPID_RUN1,
  S_SPID_RUN2,
  S_SPID_RUN3,
  S_SPID_RUN4,
  S_SPID_RUN5,
  S_SPID_RUN6,
  S_SPID_RUN7,
  S_SPID_RUN8,
  S_SPID_RUN9,
  S_SPID_RUN10,
  S_SPID_RUN11,
  S_SPID_RUN12,
  S_SPID_ATK1,
  S_SPID_ATK2,
  S_SPID_ATK3,
  S_SPID_ATK4,
  S_SPID_PAIN,
  S_SPID_PAIN2,
  S_SPID_DIE1,
  S_SPID_DIE2,
  S_SPID_DIE3,
  S_SPID_DIE4,
  S_SPID_DIE5,
  S_SPID_DIE6,
  S_SPID_DIE7,
  S_SPID_DIE8,
  S_SPID_DIE9,
  S_SPID_DIE10,
  S_SPID_DIE11,
  S_BSPI_STND,
  S_BSPI_STND2,
  S_BSPI_SIGHT,
  S_BSPI_RUN1,
  S_BSPI_RUN2,
  S_BSPI_RUN3,
  S_BSPI_RUN4,
  S_BSPI_RUN5,
  S_BSPI_RUN6,
  S_BSPI_RUN7,
  S_BSPI_RUN8,
  S_BSPI_RUN9,
  S_BSPI_RUN10,
  S_BSPI_RUN11,
  S_BSPI_RUN12,
  S_BSPI_ATK1,
  S_BSPI_ATK2,
  S_BSPI_ATK3,
  S_BSPI_ATK4,
  S_BSPI_PAIN,
  S_BSPI_PAIN2,
  S_BSPI_DIE1,
  S_BSPI_DIE2,
  S_BSPI_DIE3,
  S_BSPI_DIE4,
  S_BSPI_DIE5,
  S_BSPI_DIE6,
  S_BSPI_DIE7,
  S_BSPI_RAISE1,
  S_BSPI_RAISE2,
  S_BSPI_RAISE3,
  S_BSPI_RAISE4,
  S_BSPI_RAISE5,
  S_BSPI_RAISE6,
  S_BSPI_RAISE7,
  S_ARACH_PLAZ,
  S_ARACH_PLAZ2,
  S_ARACH_PLEX,
  S_ARACH_PLEX2,
  S_ARACH_PLEX3,
  S_ARACH_PLEX4,
  S_ARACH_PLEX5,
  S_CYBER_STND,
  S_CYBER_STND2,
  S_CYBER_RUN1,
  S_CYBER_RUN2,
  S_CYBER_RUN3,
  S_CYBER_RUN4,
  S_CYBER_RUN5,
  S_CYBER_RUN6,
  S_CYBER_RUN7,
  S_CYBER_RUN8,
  S_CYBER_ATK1,
  S_CYBER_ATK2,
  S_CYBER_ATK3,
  S_CYBER_ATK4,
  S_CYBER_ATK5,
  S_CYBER_ATK6,
  S_CYBER_PAIN,
  S_CYBER_DIE1,
  S_CYBER_DIE2,
  S_CYBER_DIE3,
  S_CYBER_DIE4,
  S_CYBER_DIE5,
  S_CYBER_DIE6,
  S_CYBER_DIE7,
  S_CYBER_DIE8,
  S_CYBER_DIE9,
  S_CYBER_DIE10,
  S_PAIN_STND,
  S_PAIN_RUN1,
  S_PAIN_RUN2,
  S_PAIN_RUN3,
  S_PAIN_RUN4,
  S_PAIN_RUN5,
  S_PAIN_RUN6,
  S_PAIN_ATK1,
  S_PAIN_ATK2,
  S_PAIN_ATK3,
  S_PAIN_ATK4,
  S_PAIN_PAIN,
  S_PAIN_PAIN2,
  S_PAIN_DIE1,
  S_PAIN_DIE2,
  S_PAIN_DIE3,
  S_PAIN_DIE4,
  S_PAIN_DIE5,
  S_PAIN_DIE6,
  S_PAIN_RAISE1,
  S_PAIN_RAISE2,
  S_PAIN_RAISE3,
  S_PAIN_RAISE4,
  S_PAIN_RAISE5,
  S_PAIN_RAISE6,
  S_SSWV_STND,
  S_SSWV_STND2,
  S_SSWV_RUN1,
  S_SSWV_RUN2,
  S_SSWV_RUN3,
  S_SSWV_RUN4,
  S_SSWV_RUN5,
  S_SSWV_RUN6,
  S_SSWV_RUN7,
  S_SSWV_RUN8,
  S_SSWV_ATK1,
  S_SSWV_ATK2,
  S_SSWV_ATK3,
  S_SSWV_ATK4,
  S_SSWV_ATK5,
  S_SSWV_ATK6,
  S_SSWV_PAIN,
  S_SSWV_PAIN2,
  S_SSWV_DIE1,
  S_SSWV_DIE2,
  S_SSWV_DIE3,
  S_SSWV_DIE4,
  S_SSWV_DIE5,
  S_SSWV_XDIE1,
  S_SSWV_XDIE2,
  S_SSWV_XDIE3,
  S_SSWV_XDIE4,
  S_SSWV_XDIE5,
  S_SSWV_XDIE6,
  S_SSWV_XDIE7,
  S_SSWV_XDIE8,
  S_SSWV_XDIE9,
  S_SSWV_RAISE1,
  S_SSWV_RAISE2,
  S_SSWV_RAISE3,
  S_SSWV_RAISE4,
  S_SSWV_RAISE5,
  S_KEENSTND,
  S_COMMKEEN,
  S_COMMKEEN2,
  S_COMMKEEN3,
  S_COMMKEEN4,
  S_COMMKEEN5,
  S_COMMKEEN6,
  S_COMMKEEN7,
  S_COMMKEEN8,
  S_COMMKEEN9,
  S_COMMKEEN10,
  S_COMMKEEN11,
  S_COMMKEEN12,
  S_KEENPAIN,
  S_KEENPAIN2,
  S_BRAIN,
  S_BRAIN_PAIN,
  S_BRAIN_DIE1,
  S_BRAIN_DIE2,
  S_BRAIN_DIE3,
  S_BRAIN_DIE4,
  S_BRAINEYE,
  S_BRAINEYESEE,
  S_BRAINEYE1,
  S_SPAWN1,
  S_SPAWN2,
  S_SPAWN3,
  S_SPAWN4,
  S_SPAWNFIRE1,
  S_SPAWNFIRE2,
  S_SPAWNFIRE3,
  S_SPAWNFIRE4,
  S_SPAWNFIRE5,
  S_SPAWNFIRE6,
  S_SPAWNFIRE7,
  S_SPAWNFIRE8,
  S_BRAINEXPLODE1,
  S_BRAINEXPLODE2,
  S_BRAINEXPLODE3,
  S_ARM1,
  S_ARM1A,
  S_ARM2,
  S_ARM2A,
  S_BAR1,
  S_BAR2,
  S_BEXP,
  S_BEXP2,
  S_BEXP3,
  S_BEXP4,
  S_BEXP5,
  S_BBAR1,
  S_BBAR2,
  S_BBAR3,
  S_BON1,
  S_BON1A,
  S_BON1B,
  S_BON1C,
  S_BON1D,
  S_BON1E,
  S_BON2,
  S_BON2A,
  S_BON2B,
  S_BON2C,
  S_BON2D,
  S_BON2E,
  S_BKEY,
  S_BKEY2,
  S_RKEY,
  S_RKEY2,
  S_YKEY,
  S_YKEY2,
  S_BSKULL,
  S_BSKULL2,
  S_RSKULL,
  S_RSKULL2,
  S_YSKULL,
  S_YSKULL2,
  S_STIM,
  S_MEDI,
  S_SOUL,
  S_SOUL2,
  S_SOUL3,
  S_SOUL4,
  S_SOUL5,
  S_SOUL6,
  S_PINV,
  S_PINV2,
  S_PINV3,
  S_PINV4,
  S_PSTR,
  S_PINS,
  S_PINS2,
  S_PINS3,
  S_PINS4,
  S_MEGA,
  S_MEGA2,
  S_MEGA3,
  S_MEGA4,
  S_SUIT,
  S_PMAP,
  S_PMAP2,
  S_PMAP3,
  S_PMAP4,
  S_PMAP5,
  S_PMAP6,
  S_PVIS,
  S_PVIS2,
  S_CLIP,
  S_AMMO,
  S_ROCK,
  S_BROK,
  S_CELL,
  S_CELP,
  S_SHEL,
  S_SBOX,
  S_BPAK,
  S_BFUG,
  S_MGUN,
  S_CSAW,
  S_LAUN,
  S_PLAS,
  S_SHOT,
  S_SHOT2,
  S_COLU,
  S_STALAG,
  S_BLOODYTWITCH,
  S_BLOODYTWITCH2,
  S_BLOODYTWITCH3,
  S_BLOODYTWITCH4,
  S_DEADTORSO,
  S_DEADBOTTOM,
  S_HEADSONSTICK,
  S_GIBS,
  S_HEADONASTICK,
  S_HEADCANDLES,
  S_HEADCANDLES2,
  S_DEADSTICK,
  S_LIVESTICK,
  S_LIVESTICK2,
  S_MEAT2,
  S_MEAT3,
  S_MEAT4,
  S_MEAT5,
  S_STALAGTITE,
  S_TALLGRNCOL,
  S_SHRTGRNCOL,
  S_TALLREDCOL,
  S_SHRTREDCOL,
  S_CANDLESTIK,
  S_CANDELABRA,
  S_SKULLCOL,
  S_TORCHTREE,
  S_BIGTREE,
  S_TECHPILLAR,
  S_EVILEYE,
  S_EVILEYE2,
  S_EVILEYE3,
  S_EVILEYE4,
  S_FLOATSKULL,
  S_FLOATSKULL2,
  S_FLOATSKULL3,
  S_HEARTCOL,
  S_HEARTCOL2,
  S_BLUETORCH,
  S_BLUETORCH2,
  S_BLUETORCH3,
  S_BLUETORCH4,
  S_GREENTORCH,
  S_GREENTORCH2,
  S_GREENTORCH3,
  S_GREENTORCH4,
  S_REDTORCH,
  S_REDTORCH2,
  S_REDTORCH3,
  S_REDTORCH4,
  S_BTORCHSHRT,
  S_BTORCHSHRT2,
  S_BTORCHSHRT3,
  S_BTORCHSHRT4,
  S_GTORCHSHRT,
  S_GTORCHSHRT2,
  S_GTORCHSHRT3,
  S_GTORCHSHRT4,
  S_RTORCHSHRT,
  S_RTORCHSHRT2,
  S_RTORCHSHRT3,
  S_RTORCHSHRT4,
  S_HANGNOGUTS,
  S_HANGBNOBRAIN,
  S_HANGTLOOKDN,
  S_HANGTSKULL,
  S_HANGTLOOKUP,
  S_HANGTNOBRAIN,
  S_COLONGIBS,
  S_SMALLPOOL,
  S_BRAINSTEM,
  S_TECHLAMP,
  S_TECHLAMP2,
  S_TECHLAMP3,
  S_TECHLAMP4,
  S_TECH2LAMP,
  S_TECH2LAMP2,
  S_TECH2LAMP3,
  S_TECH2LAMP4,
  S_TNT1, /* add state for invisible sprite          phares 3/8/98  */

  S_GRENADE,   /* killough 8/9/98: grenade launcher */
  S_DETONATE,  /* killough 8/9/98: detonation of objects */
  S_DETONATE2,
  S_DETONATE3,

  // always count dog states, even if dogs are disabled
  S_DOGS_STND,      /* killough 7/19/98: Marine's best friend :) */
  S_DOGS_STND2,
  S_DOGS_RUN1,
  S_DOGS_RUN2,
  S_DOGS_RUN3,
  S_DOGS_RUN4,
  S_DOGS_RUN5,
  S_DOGS_RUN6,
  S_DOGS_RUN7,
  S_DOGS_RUN8,
  S_DOGS_ATK1,
  S_DOGS_ATK2,
  S_DOGS_ATK3,
  S_DOGS_PAIN,
  S_DOGS_PAIN2,
  S_DOGS_DIE1,
  S_DOGS_DIE2,
  S_DOGS_DIE3,
  S_DOGS_DIE4,
  S_DOGS_DIE5,
  S_DOGS_DIE6,
  S_DOGS_RAISE1,
  S_DOGS_RAISE2,
  S_DOGS_RAISE3,
  S_DOGS_RAISE4,
  S_DOGS_RAISE5,
  S_DOGS_RAISE6,

  // add dummy beta bfg / lost soul frames for dehacked compatibility
  // fixes bug #1576151 (part 2)
  S_OLDBFG1,  // killough 7/11/98: the old BFG's 43 firing frames
  S_OLDBFG42 = S_OLDBFG1+41,
  S_OLDBFG43,

  S_PLS1BALL,      // killough 7/19/98: first plasma fireball in the beta
  S_PLS1BALL2,
  S_PLS1EXP,
  S_PLS1EXP2,
  S_PLS1EXP3,
  S_PLS1EXP4,
  S_PLS1EXP5,

  S_PLS2BALL,     // killough 7/19/98: second plasma fireball in the beta
  S_PLS2BALL2,
  S_PLS2BALLX1,
  S_PLS2BALLX2,
  S_PLS2BALLX3,
  S_BON3, // killough 7/11/98: evil sceptre in beta version
  S_BON4, // killough 7/11/98: unholy bible in beta version

  // killough 10/98: beta lost souls were different from their modern cousins
  S_BSKUL_STND,
  S_BSKUL_RUN1,
  S_BSKUL_RUN2,
  S_BSKUL_RUN3,
  S_BSKUL_RUN4,
  S_BSKUL_ATK1,
  S_BSKUL_ATK2,
  S_BSKUL_ATK3,
  S_BSKUL_PAIN1,
  S_BSKUL_PAIN2,
  S_BSKUL_PAIN3,
  S_BSKUL_DIE1,
  S_BSKUL_DIE2,
  S_BSKUL_DIE3,
  S_BSKUL_DIE4,
  S_BSKUL_DIE5,
  S_BSKUL_DIE6,
  S_BSKUL_DIE7,
  S_BSKUL_DIE8,

  S_MUSHROOM,  /* killough 10/98: mushroom explosion effect */

  S_PLAY_GDIE1,
  S_PLAY_GDIE2,
  S_PLAY_GDIE3,
  S_PLAY_GDIE4,
  S_PLAY_GDIE5,
  S_PLAY_GDIE6,
  S_PLAY_GDIE7,
  S_PLAY_GDIE8,
  S_PLAY_GDIE9,

  EXTRASTATES = 1089, // extra dehacked states
  NUMSTATES = 4000,  /* Counter of how many there are */

  // heretic
  HERETIC_S_NULL = 0,
  HERETIC_S_FREETARGMOBJ,
  HERETIC_S_ITEM_PTN1_1,
  HERETIC_S_ITEM_PTN1_2,
  HERETIC_S_ITEM_PTN1_3,
  HERETIC_S_ITEM_SHLD1,
  HERETIC_S_ITEM_SHD2_1,
  HERETIC_S_ITEM_BAGH1,
  HERETIC_S_ITEM_SPMP1,
  HERETIC_S_HIDESPECIAL1,
  HERETIC_S_HIDESPECIAL2,
  HERETIC_S_HIDESPECIAL3,
  HERETIC_S_HIDESPECIAL4,
  HERETIC_S_HIDESPECIAL5,
  HERETIC_S_HIDESPECIAL6,
  HERETIC_S_HIDESPECIAL7,
  HERETIC_S_HIDESPECIAL8,
  HERETIC_S_HIDESPECIAL9,
  HERETIC_S_HIDESPECIAL10,
  HERETIC_S_HIDESPECIAL11,
  HERETIC_S_DORMANTARTI1,
  HERETIC_S_DORMANTARTI2,
  HERETIC_S_DORMANTARTI3,
  HERETIC_S_DORMANTARTI4,
  HERETIC_S_DORMANTARTI5,
  HERETIC_S_DORMANTARTI6,
  HERETIC_S_DORMANTARTI7,
  HERETIC_S_DORMANTARTI8,
  HERETIC_S_DORMANTARTI9,
  HERETIC_S_DORMANTARTI10,
  HERETIC_S_DORMANTARTI11,
  HERETIC_S_DORMANTARTI12,
  HERETIC_S_DORMANTARTI13,
  HERETIC_S_DORMANTARTI14,
  HERETIC_S_DORMANTARTI15,
  HERETIC_S_DORMANTARTI16,
  HERETIC_S_DORMANTARTI17,
  HERETIC_S_DORMANTARTI18,
  HERETIC_S_DORMANTARTI19,
  HERETIC_S_DORMANTARTI20,
  HERETIC_S_DORMANTARTI21,
  HERETIC_S_DEADARTI1,
  HERETIC_S_DEADARTI2,
  HERETIC_S_DEADARTI3,
  HERETIC_S_DEADARTI4,
  HERETIC_S_DEADARTI5,
  HERETIC_S_DEADARTI6,
  HERETIC_S_DEADARTI7,
  HERETIC_S_DEADARTI8,
  HERETIC_S_DEADARTI9,
  HERETIC_S_DEADARTI10,
  HERETIC_S_ARTI_INVS1,
  HERETIC_S_ARTI_PTN2_1,
  HERETIC_S_ARTI_PTN2_2,
  HERETIC_S_ARTI_PTN2_3,
  HERETIC_S_ARTI_SOAR1,
  HERETIC_S_ARTI_SOAR2,
  HERETIC_S_ARTI_SOAR3,
  HERETIC_S_ARTI_SOAR4,
  HERETIC_S_ARTI_INVU1,
  HERETIC_S_ARTI_INVU2,
  HERETIC_S_ARTI_INVU3,
  HERETIC_S_ARTI_INVU4,
  HERETIC_S_ARTI_PWBK1,
  HERETIC_S_ARTI_EGGC1,
  HERETIC_S_ARTI_EGGC2,
  HERETIC_S_ARTI_EGGC3,
  HERETIC_S_ARTI_EGGC4,
  HERETIC_S_EGGFX1,
  HERETIC_S_EGGFX2,
  HERETIC_S_EGGFX3,
  HERETIC_S_EGGFX4,
  HERETIC_S_EGGFX5,
  HERETIC_S_EGGFXI1_1,
  HERETIC_S_EGGFXI1_2,
  HERETIC_S_EGGFXI1_3,
  HERETIC_S_EGGFXI1_4,
  HERETIC_S_ARTI_SPHL1,
  HERETIC_S_ARTI_TRCH1,
  HERETIC_S_ARTI_TRCH2,
  HERETIC_S_ARTI_TRCH3,
  HERETIC_S_ARTI_FBMB1,
  HERETIC_S_FIREBOMB1,
  HERETIC_S_FIREBOMB2,
  HERETIC_S_FIREBOMB3,
  HERETIC_S_FIREBOMB4,
  HERETIC_S_FIREBOMB5,
  HERETIC_S_FIREBOMB6,
  HERETIC_S_FIREBOMB7,
  HERETIC_S_FIREBOMB8,
  HERETIC_S_FIREBOMB9,
  HERETIC_S_FIREBOMB10,
  HERETIC_S_FIREBOMB11,
  HERETIC_S_ARTI_ATLP1,
  HERETIC_S_ARTI_ATLP2,
  HERETIC_S_ARTI_ATLP3,
  HERETIC_S_ARTI_ATLP4,
  HERETIC_S_POD_WAIT1,
  HERETIC_S_POD_PAIN1,
  HERETIC_S_POD_DIE1,
  HERETIC_S_POD_DIE2,
  HERETIC_S_POD_DIE3,
  HERETIC_S_POD_DIE4,
  HERETIC_S_POD_GROW1,
  HERETIC_S_POD_GROW2,
  HERETIC_S_POD_GROW3,
  HERETIC_S_POD_GROW4,
  HERETIC_S_POD_GROW5,
  HERETIC_S_POD_GROW6,
  HERETIC_S_POD_GROW7,
  HERETIC_S_POD_GROW8,
  HERETIC_S_PODGOO1,
  HERETIC_S_PODGOO2,
  HERETIC_S_PODGOOX,
  HERETIC_S_PODGENERATOR,
  HERETIC_S_SPLASH1,
  HERETIC_S_SPLASH2,
  HERETIC_S_SPLASH3,
  HERETIC_S_SPLASH4,
  HERETIC_S_SPLASHX,
  HERETIC_S_SPLASHBASE1,
  HERETIC_S_SPLASHBASE2,
  HERETIC_S_SPLASHBASE3,
  HERETIC_S_SPLASHBASE4,
  HERETIC_S_SPLASHBASE5,
  HERETIC_S_SPLASHBASE6,
  HERETIC_S_SPLASHBASE7,
  HERETIC_S_LAVASPLASH1,
  HERETIC_S_LAVASPLASH2,
  HERETIC_S_LAVASPLASH3,
  HERETIC_S_LAVASPLASH4,
  HERETIC_S_LAVASPLASH5,
  HERETIC_S_LAVASPLASH6,
  HERETIC_S_LAVASMOKE1,
  HERETIC_S_LAVASMOKE2,
  HERETIC_S_LAVASMOKE3,
  HERETIC_S_LAVASMOKE4,
  HERETIC_S_LAVASMOKE5,
  HERETIC_S_SLUDGECHUNK1,
  HERETIC_S_SLUDGECHUNK2,
  HERETIC_S_SLUDGECHUNK3,
  HERETIC_S_SLUDGECHUNK4,
  HERETIC_S_SLUDGECHUNKX,
  HERETIC_S_SLUDGESPLASH1,
  HERETIC_S_SLUDGESPLASH2,
  HERETIC_S_SLUDGESPLASH3,
  HERETIC_S_SLUDGESPLASH4,
  HERETIC_S_SKULLHANG70_1,
  HERETIC_S_SKULLHANG60_1,
  HERETIC_S_SKULLHANG45_1,
  HERETIC_S_SKULLHANG35_1,
  HERETIC_S_CHANDELIER1,
  HERETIC_S_CHANDELIER2,
  HERETIC_S_CHANDELIER3,
  HERETIC_S_SERPTORCH1,
  HERETIC_S_SERPTORCH2,
  HERETIC_S_SERPTORCH3,
  HERETIC_S_SMALLPILLAR,
  HERETIC_S_STALAGMITESMALL,
  HERETIC_S_STALAGMITELARGE,
  HERETIC_S_STALACTITESMALL,
  HERETIC_S_STALACTITELARGE,
  HERETIC_S_FIREBRAZIER1,
  HERETIC_S_FIREBRAZIER2,
  HERETIC_S_FIREBRAZIER3,
  HERETIC_S_FIREBRAZIER4,
  HERETIC_S_FIREBRAZIER5,
  HERETIC_S_FIREBRAZIER6,
  HERETIC_S_FIREBRAZIER7,
  HERETIC_S_FIREBRAZIER8,
  HERETIC_S_BARREL,
  HERETIC_S_BRPILLAR,
  HERETIC_S_MOSS1,
  HERETIC_S_MOSS2,
  HERETIC_S_WALLTORCH1,
  HERETIC_S_WALLTORCH2,
  HERETIC_S_WALLTORCH3,
  HERETIC_S_HANGINGCORPSE,
  HERETIC_S_KEYGIZMO1,
  HERETIC_S_KEYGIZMO2,
  HERETIC_S_KEYGIZMO3,
  HERETIC_S_KGZ_START,
  HERETIC_S_KGZ_BLUEFLOAT1,
  HERETIC_S_KGZ_GREENFLOAT1,
  HERETIC_S_KGZ_YELLOWFLOAT1,
  HERETIC_S_VOLCANO1,
  HERETIC_S_VOLCANO2,
  HERETIC_S_VOLCANO3,
  HERETIC_S_VOLCANO4,
  HERETIC_S_VOLCANO5,
  HERETIC_S_VOLCANO6,
  HERETIC_S_VOLCANO7,
  HERETIC_S_VOLCANO8,
  HERETIC_S_VOLCANO9,
  HERETIC_S_VOLCANOBALL1,
  HERETIC_S_VOLCANOBALL2,
  HERETIC_S_VOLCANOBALLX1,
  HERETIC_S_VOLCANOBALLX2,
  HERETIC_S_VOLCANOBALLX3,
  HERETIC_S_VOLCANOBALLX4,
  HERETIC_S_VOLCANOBALLX5,
  HERETIC_S_VOLCANOBALLX6,
  HERETIC_S_VOLCANOTBALL1,
  HERETIC_S_VOLCANOTBALL2,
  HERETIC_S_VOLCANOTBALLX1,
  HERETIC_S_VOLCANOTBALLX2,
  HERETIC_S_VOLCANOTBALLX3,
  HERETIC_S_VOLCANOTBALLX4,
  HERETIC_S_VOLCANOTBALLX5,
  HERETIC_S_VOLCANOTBALLX6,
  HERETIC_S_VOLCANOTBALLX7,
  HERETIC_S_TELEGLITGEN1,
  HERETIC_S_TELEGLITGEN2,
  HERETIC_S_TELEGLITTER1_1,
  HERETIC_S_TELEGLITTER1_2,
  HERETIC_S_TELEGLITTER1_3,
  HERETIC_S_TELEGLITTER1_4,
  HERETIC_S_TELEGLITTER1_5,
  HERETIC_S_TELEGLITTER2_1,
  HERETIC_S_TELEGLITTER2_2,
  HERETIC_S_TELEGLITTER2_3,
  HERETIC_S_TELEGLITTER2_4,
  HERETIC_S_TELEGLITTER2_5,
  HERETIC_S_TFOG1,
  HERETIC_S_TFOG2,
  HERETIC_S_TFOG3,
  HERETIC_S_TFOG4,
  HERETIC_S_TFOG5,
  HERETIC_S_TFOG6,
  HERETIC_S_TFOG7,
  HERETIC_S_TFOG8,
  HERETIC_S_TFOG9,
  HERETIC_S_TFOG10,
  HERETIC_S_TFOG11,
  HERETIC_S_TFOG12,
  HERETIC_S_TFOG13,
  HERETIC_S_LIGHTDONE,
  HERETIC_S_STAFFREADY,
  HERETIC_S_STAFFDOWN,
  HERETIC_S_STAFFUP,
  HERETIC_S_STAFFREADY2_1,
  HERETIC_S_STAFFREADY2_2,
  HERETIC_S_STAFFREADY2_3,
  HERETIC_S_STAFFDOWN2,
  HERETIC_S_STAFFUP2,
  HERETIC_S_STAFFATK1_1,
  HERETIC_S_STAFFATK1_2,
  HERETIC_S_STAFFATK1_3,
  HERETIC_S_STAFFATK2_1,
  HERETIC_S_STAFFATK2_2,
  HERETIC_S_STAFFATK2_3,
  HERETIC_S_STAFFPUFF1,
  HERETIC_S_STAFFPUFF2,
  HERETIC_S_STAFFPUFF3,
  HERETIC_S_STAFFPUFF4,
  HERETIC_S_STAFFPUFF2_1,
  HERETIC_S_STAFFPUFF2_2,
  HERETIC_S_STAFFPUFF2_3,
  HERETIC_S_STAFFPUFF2_4,
  HERETIC_S_STAFFPUFF2_5,
  HERETIC_S_STAFFPUFF2_6,
  HERETIC_S_BEAKREADY,
  HERETIC_S_BEAKDOWN,
  HERETIC_S_BEAKUP,
  HERETIC_S_BEAKATK1_1,
  HERETIC_S_BEAKATK2_1,
  HERETIC_S_WGNT,
  HERETIC_S_GAUNTLETREADY,
  HERETIC_S_GAUNTLETDOWN,
  HERETIC_S_GAUNTLETUP,
  HERETIC_S_GAUNTLETREADY2_1,
  HERETIC_S_GAUNTLETREADY2_2,
  HERETIC_S_GAUNTLETREADY2_3,
  HERETIC_S_GAUNTLETDOWN2,
  HERETIC_S_GAUNTLETUP2,
  HERETIC_S_GAUNTLETATK1_1,
  HERETIC_S_GAUNTLETATK1_2,
  HERETIC_S_GAUNTLETATK1_3,
  HERETIC_S_GAUNTLETATK1_4,
  HERETIC_S_GAUNTLETATK1_5,
  HERETIC_S_GAUNTLETATK1_6,
  HERETIC_S_GAUNTLETATK1_7,
  HERETIC_S_GAUNTLETATK2_1,
  HERETIC_S_GAUNTLETATK2_2,
  HERETIC_S_GAUNTLETATK2_3,
  HERETIC_S_GAUNTLETATK2_4,
  HERETIC_S_GAUNTLETATK2_5,
  HERETIC_S_GAUNTLETATK2_6,
  HERETIC_S_GAUNTLETATK2_7,
  HERETIC_S_GAUNTLETPUFF1_1,
  HERETIC_S_GAUNTLETPUFF1_2,
  HERETIC_S_GAUNTLETPUFF1_3,
  HERETIC_S_GAUNTLETPUFF1_4,
  HERETIC_S_GAUNTLETPUFF2_1,
  HERETIC_S_GAUNTLETPUFF2_2,
  HERETIC_S_GAUNTLETPUFF2_3,
  HERETIC_S_GAUNTLETPUFF2_4,
  HERETIC_S_BLSR,
  HERETIC_S_BLASTERREADY,
  HERETIC_S_BLASTERDOWN,
  HERETIC_S_BLASTERUP,
  HERETIC_S_BLASTERATK1_1,
  HERETIC_S_BLASTERATK1_2,
  HERETIC_S_BLASTERATK1_3,
  HERETIC_S_BLASTERATK1_4,
  HERETIC_S_BLASTERATK1_5,
  HERETIC_S_BLASTERATK1_6,
  HERETIC_S_BLASTERATK2_1,
  HERETIC_S_BLASTERATK2_2,
  HERETIC_S_BLASTERATK2_3,
  HERETIC_S_BLASTERATK2_4,
  HERETIC_S_BLASTERATK2_5,
  HERETIC_S_BLASTERATK2_6,
  HERETIC_S_BLASTERFX1_1,
  HERETIC_S_BLASTERFXI1_1,
  HERETIC_S_BLASTERFXI1_2,
  HERETIC_S_BLASTERFXI1_3,
  HERETIC_S_BLASTERFXI1_4,
  HERETIC_S_BLASTERFXI1_5,
  HERETIC_S_BLASTERFXI1_6,
  HERETIC_S_BLASTERFXI1_7,
  HERETIC_S_BLASTERSMOKE1,
  HERETIC_S_BLASTERSMOKE2,
  HERETIC_S_BLASTERSMOKE3,
  HERETIC_S_BLASTERSMOKE4,
  HERETIC_S_BLASTERSMOKE5,
  HERETIC_S_RIPPER1,
  HERETIC_S_RIPPER2,
  HERETIC_S_RIPPERX1,
  HERETIC_S_RIPPERX2,
  HERETIC_S_RIPPERX3,
  HERETIC_S_RIPPERX4,
  HERETIC_S_RIPPERX5,
  HERETIC_S_BLASTERPUFF1_1,
  HERETIC_S_BLASTERPUFF1_2,
  HERETIC_S_BLASTERPUFF1_3,
  HERETIC_S_BLASTERPUFF1_4,
  HERETIC_S_BLASTERPUFF1_5,
  HERETIC_S_BLASTERPUFF2_1,
  HERETIC_S_BLASTERPUFF2_2,
  HERETIC_S_BLASTERPUFF2_3,
  HERETIC_S_BLASTERPUFF2_4,
  HERETIC_S_BLASTERPUFF2_5,
  HERETIC_S_BLASTERPUFF2_6,
  HERETIC_S_BLASTERPUFF2_7,
  HERETIC_S_WMCE,
  HERETIC_S_MACEREADY,
  HERETIC_S_MACEDOWN,
  HERETIC_S_MACEUP,
  HERETIC_S_MACEATK1_1,
  HERETIC_S_MACEATK1_2,
  HERETIC_S_MACEATK1_3,
  HERETIC_S_MACEATK1_4,
  HERETIC_S_MACEATK1_5,
  HERETIC_S_MACEATK1_6,
  HERETIC_S_MACEATK1_7,
  HERETIC_S_MACEATK1_8,
  HERETIC_S_MACEATK1_9,
  HERETIC_S_MACEATK1_10,
  HERETIC_S_MACEATK2_1,
  HERETIC_S_MACEATK2_2,
  HERETIC_S_MACEATK2_3,
  HERETIC_S_MACEATK2_4,
  HERETIC_S_MACEFX1_1,
  HERETIC_S_MACEFX1_2,
  HERETIC_S_MACEFXI1_1,
  HERETIC_S_MACEFXI1_2,
  HERETIC_S_MACEFXI1_3,
  HERETIC_S_MACEFXI1_4,
  HERETIC_S_MACEFXI1_5,
  HERETIC_S_MACEFX2_1,
  HERETIC_S_MACEFX2_2,
  HERETIC_S_MACEFXI2_1,
  HERETIC_S_MACEFX3_1,
  HERETIC_S_MACEFX3_2,
  HERETIC_S_MACEFX4_1,
  HERETIC_S_MACEFXI4_1,
  HERETIC_S_WSKL,
  HERETIC_S_HORNRODREADY,
  HERETIC_S_HORNRODDOWN,
  HERETIC_S_HORNRODUP,
  HERETIC_S_HORNRODATK1_1,
  HERETIC_S_HORNRODATK1_2,
  HERETIC_S_HORNRODATK1_3,
  HERETIC_S_HORNRODATK2_1,
  HERETIC_S_HORNRODATK2_2,
  HERETIC_S_HORNRODATK2_3,
  HERETIC_S_HORNRODATK2_4,
  HERETIC_S_HORNRODATK2_5,
  HERETIC_S_HORNRODATK2_6,
  HERETIC_S_HORNRODATK2_7,
  HERETIC_S_HORNRODATK2_8,
  HERETIC_S_HORNRODATK2_9,
  HERETIC_S_HRODFX1_1,
  HERETIC_S_HRODFX1_2,
  HERETIC_S_HRODFXI1_1,
  HERETIC_S_HRODFXI1_2,
  HERETIC_S_HRODFXI1_3,
  HERETIC_S_HRODFXI1_4,
  HERETIC_S_HRODFXI1_5,
  HERETIC_S_HRODFXI1_6,
  HERETIC_S_HRODFX2_1,
  HERETIC_S_HRODFX2_2,
  HERETIC_S_HRODFX2_3,
  HERETIC_S_HRODFX2_4,
  HERETIC_S_HRODFXI2_1,
  HERETIC_S_HRODFXI2_2,
  HERETIC_S_HRODFXI2_3,
  HERETIC_S_HRODFXI2_4,
  HERETIC_S_HRODFXI2_5,
  HERETIC_S_HRODFXI2_6,
  HERETIC_S_HRODFXI2_7,
  HERETIC_S_HRODFXI2_8,
  HERETIC_S_RAINPLR1_1,
  HERETIC_S_RAINPLR2_1,
  HERETIC_S_RAINPLR3_1,
  HERETIC_S_RAINPLR4_1,
  HERETIC_S_RAINPLR1X_1,
  HERETIC_S_RAINPLR1X_2,
  HERETIC_S_RAINPLR1X_3,
  HERETIC_S_RAINPLR1X_4,
  HERETIC_S_RAINPLR1X_5,
  HERETIC_S_RAINPLR2X_1,
  HERETIC_S_RAINPLR2X_2,
  HERETIC_S_RAINPLR2X_3,
  HERETIC_S_RAINPLR2X_4,
  HERETIC_S_RAINPLR2X_5,
  HERETIC_S_RAINPLR3X_1,
  HERETIC_S_RAINPLR3X_2,
  HERETIC_S_RAINPLR3X_3,
  HERETIC_S_RAINPLR3X_4,
  HERETIC_S_RAINPLR3X_5,
  HERETIC_S_RAINPLR4X_1,
  HERETIC_S_RAINPLR4X_2,
  HERETIC_S_RAINPLR4X_3,
  HERETIC_S_RAINPLR4X_4,
  HERETIC_S_RAINPLR4X_5,
  HERETIC_S_RAINAIRXPLR1_1,
  HERETIC_S_RAINAIRXPLR2_1,
  HERETIC_S_RAINAIRXPLR3_1,
  HERETIC_S_RAINAIRXPLR4_1,
  HERETIC_S_RAINAIRXPLR1_2,
  HERETIC_S_RAINAIRXPLR2_2,
  HERETIC_S_RAINAIRXPLR3_2,
  HERETIC_S_RAINAIRXPLR4_2,
  HERETIC_S_RAINAIRXPLR1_3,
  HERETIC_S_RAINAIRXPLR2_3,
  HERETIC_S_RAINAIRXPLR3_3,
  HERETIC_S_RAINAIRXPLR4_3,
  HERETIC_S_GOLDWANDREADY,
  HERETIC_S_GOLDWANDDOWN,
  HERETIC_S_GOLDWANDUP,
  HERETIC_S_GOLDWANDATK1_1,
  HERETIC_S_GOLDWANDATK1_2,
  HERETIC_S_GOLDWANDATK1_3,
  HERETIC_S_GOLDWANDATK1_4,
  HERETIC_S_GOLDWANDATK2_1,
  HERETIC_S_GOLDWANDATK2_2,
  HERETIC_S_GOLDWANDATK2_3,
  HERETIC_S_GOLDWANDATK2_4,
  HERETIC_S_GWANDFX1_1,
  HERETIC_S_GWANDFX1_2,
  HERETIC_S_GWANDFXI1_1,
  HERETIC_S_GWANDFXI1_2,
  HERETIC_S_GWANDFXI1_3,
  HERETIC_S_GWANDFXI1_4,
  HERETIC_S_GWANDFX2_1,
  HERETIC_S_GWANDFX2_2,
  HERETIC_S_GWANDPUFF1_1,
  HERETIC_S_GWANDPUFF1_2,
  HERETIC_S_GWANDPUFF1_3,
  HERETIC_S_GWANDPUFF1_4,
  HERETIC_S_GWANDPUFF1_5,
  HERETIC_S_WPHX,
  HERETIC_S_PHOENIXREADY,
  HERETIC_S_PHOENIXDOWN,
  HERETIC_S_PHOENIXUP,
  HERETIC_S_PHOENIXATK1_1,
  HERETIC_S_PHOENIXATK1_2,
  HERETIC_S_PHOENIXATK1_3,
  HERETIC_S_PHOENIXATK1_4,
  HERETIC_S_PHOENIXATK1_5,
  HERETIC_S_PHOENIXATK2_1,
  HERETIC_S_PHOENIXATK2_2,
  HERETIC_S_PHOENIXATK2_3,
  HERETIC_S_PHOENIXATK2_4,
  HERETIC_S_PHOENIXFX1_1,
  HERETIC_S_PHOENIXFXI1_1,
  HERETIC_S_PHOENIXFXI1_2,
  HERETIC_S_PHOENIXFXI1_3,
  HERETIC_S_PHOENIXFXI1_4,
  HERETIC_S_PHOENIXFXI1_5,
  HERETIC_S_PHOENIXFXI1_6,
  HERETIC_S_PHOENIXFXI1_7,
  HERETIC_S_PHOENIXFXI1_8,
  HERETIC_S_PHOENIXFXIX_1,      // [ States in Heretic 1.0 that were removed
  HERETIC_S_PHOENIXFXIX_2,
  HERETIC_S_PHOENIXFXIX_3,      // ]
  HERETIC_S_PHOENIXPUFF1,
  HERETIC_S_PHOENIXPUFF2,
  HERETIC_S_PHOENIXPUFF3,
  HERETIC_S_PHOENIXPUFF4,
  HERETIC_S_PHOENIXPUFF5,
  HERETIC_S_PHOENIXFX2_1,
  HERETIC_S_PHOENIXFX2_2,
  HERETIC_S_PHOENIXFX2_3,
  HERETIC_S_PHOENIXFX2_4,
  HERETIC_S_PHOENIXFX2_5,
  HERETIC_S_PHOENIXFX2_6,
  HERETIC_S_PHOENIXFX2_7,
  HERETIC_S_PHOENIXFX2_8,
  HERETIC_S_PHOENIXFX2_9,
  HERETIC_S_PHOENIXFX2_10,
  HERETIC_S_PHOENIXFXI2_1,
  HERETIC_S_PHOENIXFXI2_2,
  HERETIC_S_PHOENIXFXI2_3,
  HERETIC_S_PHOENIXFXI2_4,
  HERETIC_S_PHOENIXFXI2_5,
  HERETIC_S_WBOW,
  HERETIC_S_CRBOW1,
  HERETIC_S_CRBOW2,
  HERETIC_S_CRBOW3,
  HERETIC_S_CRBOW4,
  HERETIC_S_CRBOW5,
  HERETIC_S_CRBOW6,
  HERETIC_S_CRBOW7,
  HERETIC_S_CRBOW8,
  HERETIC_S_CRBOW9,
  HERETIC_S_CRBOW10,
  HERETIC_S_CRBOW11,
  HERETIC_S_CRBOW12,
  HERETIC_S_CRBOW13,
  HERETIC_S_CRBOW14,
  HERETIC_S_CRBOW15,
  HERETIC_S_CRBOW16,
  HERETIC_S_CRBOW17,
  HERETIC_S_CRBOW18,
  HERETIC_S_CRBOWDOWN,
  HERETIC_S_CRBOWUP,
  HERETIC_S_CRBOWATK1_1,
  HERETIC_S_CRBOWATK1_2,
  HERETIC_S_CRBOWATK1_3,
  HERETIC_S_CRBOWATK1_4,
  HERETIC_S_CRBOWATK1_5,
  HERETIC_S_CRBOWATK1_6,
  HERETIC_S_CRBOWATK1_7,
  HERETIC_S_CRBOWATK1_8,
  HERETIC_S_CRBOWATK2_1,
  HERETIC_S_CRBOWATK2_2,
  HERETIC_S_CRBOWATK2_3,
  HERETIC_S_CRBOWATK2_4,
  HERETIC_S_CRBOWATK2_5,
  HERETIC_S_CRBOWATK2_6,
  HERETIC_S_CRBOWATK2_7,
  HERETIC_S_CRBOWATK2_8,
  HERETIC_S_CRBOWFX1,
  HERETIC_S_CRBOWFXI1_1,
  HERETIC_S_CRBOWFXI1_2,
  HERETIC_S_CRBOWFXI1_3,
  HERETIC_S_CRBOWFX2,
  HERETIC_S_CRBOWFX3,
  HERETIC_S_CRBOWFXI3_1,
  HERETIC_S_CRBOWFXI3_2,
  HERETIC_S_CRBOWFXI3_3,
  HERETIC_S_CRBOWFX4_1,
  HERETIC_S_CRBOWFX4_2,
  HERETIC_S_BLOOD1,
  HERETIC_S_BLOOD2,
  HERETIC_S_BLOOD3,
  HERETIC_S_BLOODSPLATTER1,
  HERETIC_S_BLOODSPLATTER2,
  HERETIC_S_BLOODSPLATTER3,
  HERETIC_S_BLOODSPLATTERX,
  HERETIC_S_PLAY,
  HERETIC_S_PLAY_RUN1,
  HERETIC_S_PLAY_RUN2,
  HERETIC_S_PLAY_RUN3,
  HERETIC_S_PLAY_RUN4,
  HERETIC_S_PLAY_ATK1,
  HERETIC_S_PLAY_ATK2,
  HERETIC_S_PLAY_PAIN,
  HERETIC_S_PLAY_PAIN2,
  HERETIC_S_PLAY_DIE1,
  HERETIC_S_PLAY_DIE2,
  HERETIC_S_PLAY_DIE3,
  HERETIC_S_PLAY_DIE4,
  HERETIC_S_PLAY_DIE5,
  HERETIC_S_PLAY_DIE6,
  HERETIC_S_PLAY_DIE7,
  HERETIC_S_PLAY_DIE8,
  HERETIC_S_PLAY_DIE9,
  HERETIC_S_PLAY_XDIE1,
  HERETIC_S_PLAY_XDIE2,
  HERETIC_S_PLAY_XDIE3,
  HERETIC_S_PLAY_XDIE4,
  HERETIC_S_PLAY_XDIE5,
  HERETIC_S_PLAY_XDIE6,
  HERETIC_S_PLAY_XDIE7,
  HERETIC_S_PLAY_XDIE8,
  HERETIC_S_PLAY_XDIE9,
  HERETIC_S_PLAY_FDTH1,
  HERETIC_S_PLAY_FDTH2,
  HERETIC_S_PLAY_FDTH3,
  HERETIC_S_PLAY_FDTH4,
  HERETIC_S_PLAY_FDTH5,
  HERETIC_S_PLAY_FDTH6,
  HERETIC_S_PLAY_FDTH7,
  HERETIC_S_PLAY_FDTH8,
  HERETIC_S_PLAY_FDTH9,
  HERETIC_S_PLAY_FDTH10,
  HERETIC_S_PLAY_FDTH11,
  HERETIC_S_PLAY_FDTH12,
  HERETIC_S_PLAY_FDTH13,
  HERETIC_S_PLAY_FDTH14,
  HERETIC_S_PLAY_FDTH15,
  HERETIC_S_PLAY_FDTH16,
  HERETIC_S_PLAY_FDTH17,
  HERETIC_S_PLAY_FDTH18,
  HERETIC_S_PLAY_FDTH19,    // < These two frames were not present in the Heretic
  HERETIC_S_PLAY_FDTH20,    // < 1.0 executable (fire death animation was extended)
  HERETIC_S_BLOODYSKULL1,
  HERETIC_S_BLOODYSKULL2,
  HERETIC_S_BLOODYSKULL3,
  HERETIC_S_BLOODYSKULL4,
  HERETIC_S_BLOODYSKULL5,
  HERETIC_S_BLOODYSKULLX1,
  HERETIC_S_BLOODYSKULLX2,
  HERETIC_S_CHICPLAY,
  HERETIC_S_CHICPLAY_RUN1,
  HERETIC_S_CHICPLAY_RUN2,
  HERETIC_S_CHICPLAY_RUN3,
  HERETIC_S_CHICPLAY_RUN4,
  HERETIC_S_CHICPLAY_ATK1,
  HERETIC_S_CHICPLAY_PAIN,
  HERETIC_S_CHICPLAY_PAIN2,
  HERETIC_S_CHICKEN_LOOK1,
  HERETIC_S_CHICKEN_LOOK2,
  HERETIC_S_CHICKEN_WALK1,
  HERETIC_S_CHICKEN_WALK2,
  HERETIC_S_CHICKEN_PAIN1,
  HERETIC_S_CHICKEN_PAIN2,
  HERETIC_S_CHICKEN_ATK1,
  HERETIC_S_CHICKEN_ATK2,
  HERETIC_S_CHICKEN_DIE1,
  HERETIC_S_CHICKEN_DIE2,
  HERETIC_S_CHICKEN_DIE3,
  HERETIC_S_CHICKEN_DIE4,
  HERETIC_S_CHICKEN_DIE5,
  HERETIC_S_CHICKEN_DIE6,
  HERETIC_S_CHICKEN_DIE7,
  HERETIC_S_CHICKEN_DIE8,
  HERETIC_S_FEATHER1,
  HERETIC_S_FEATHER2,
  HERETIC_S_FEATHER3,
  HERETIC_S_FEATHER4,
  HERETIC_S_FEATHER5,
  HERETIC_S_FEATHER6,
  HERETIC_S_FEATHER7,
  HERETIC_S_FEATHER8,
  HERETIC_S_FEATHERX,
  HERETIC_S_MUMMY_LOOK1,
  HERETIC_S_MUMMY_LOOK2,
  HERETIC_S_MUMMY_WALK1,
  HERETIC_S_MUMMY_WALK2,
  HERETIC_S_MUMMY_WALK3,
  HERETIC_S_MUMMY_WALK4,
  HERETIC_S_MUMMY_ATK1,
  HERETIC_S_MUMMY_ATK2,
  HERETIC_S_MUMMY_ATK3,
  HERETIC_S_MUMMYL_ATK1,
  HERETIC_S_MUMMYL_ATK2,
  HERETIC_S_MUMMYL_ATK3,
  HERETIC_S_MUMMYL_ATK4,
  HERETIC_S_MUMMYL_ATK5,
  HERETIC_S_MUMMYL_ATK6,
  HERETIC_S_MUMMY_PAIN1,
  HERETIC_S_MUMMY_PAIN2,
  HERETIC_S_MUMMY_DIE1,
  HERETIC_S_MUMMY_DIE2,
  HERETIC_S_MUMMY_DIE3,
  HERETIC_S_MUMMY_DIE4,
  HERETIC_S_MUMMY_DIE5,
  HERETIC_S_MUMMY_DIE6,
  HERETIC_S_MUMMY_DIE7,
  HERETIC_S_MUMMY_DIE8,
  HERETIC_S_MUMMY_SOUL1,
  HERETIC_S_MUMMY_SOUL2,
  HERETIC_S_MUMMY_SOUL3,
  HERETIC_S_MUMMY_SOUL4,
  HERETIC_S_MUMMY_SOUL5,
  HERETIC_S_MUMMY_SOUL6,
  HERETIC_S_MUMMY_SOUL7,
  HERETIC_S_MUMMYFX1_1,
  HERETIC_S_MUMMYFX1_2,
  HERETIC_S_MUMMYFX1_3,
  HERETIC_S_MUMMYFX1_4,
  HERETIC_S_MUMMYFXI1_1,
  HERETIC_S_MUMMYFXI1_2,
  HERETIC_S_MUMMYFXI1_3,
  HERETIC_S_MUMMYFXI1_4,
  HERETIC_S_BEAST_LOOK1,
  HERETIC_S_BEAST_LOOK2,
  HERETIC_S_BEAST_WALK1,
  HERETIC_S_BEAST_WALK2,
  HERETIC_S_BEAST_WALK3,
  HERETIC_S_BEAST_WALK4,
  HERETIC_S_BEAST_WALK5,
  HERETIC_S_BEAST_WALK6,
  HERETIC_S_BEAST_ATK1,
  HERETIC_S_BEAST_ATK2,
  HERETIC_S_BEAST_PAIN1,
  HERETIC_S_BEAST_PAIN2,
  HERETIC_S_BEAST_DIE1,
  HERETIC_S_BEAST_DIE2,
  HERETIC_S_BEAST_DIE3,
  HERETIC_S_BEAST_DIE4,
  HERETIC_S_BEAST_DIE5,
  HERETIC_S_BEAST_DIE6,
  HERETIC_S_BEAST_DIE7,
  HERETIC_S_BEAST_DIE8,
  HERETIC_S_BEAST_DIE9,
  HERETIC_S_BEAST_XDIE1,
  HERETIC_S_BEAST_XDIE2,
  HERETIC_S_BEAST_XDIE3,
  HERETIC_S_BEAST_XDIE4,
  HERETIC_S_BEAST_XDIE5,
  HERETIC_S_BEAST_XDIE6,
  HERETIC_S_BEAST_XDIE7,
  HERETIC_S_BEAST_XDIE8,
  HERETIC_S_BEASTBALL1,
  HERETIC_S_BEASTBALL2,
  HERETIC_S_BEASTBALL3,
  HERETIC_S_BEASTBALL4,
  HERETIC_S_BEASTBALL5,
  HERETIC_S_BEASTBALL6,
  HERETIC_S_BEASTBALLX1,
  HERETIC_S_BEASTBALLX2,
  HERETIC_S_BEASTBALLX3,
  HERETIC_S_BEASTBALLX4,
  HERETIC_S_BEASTBALLX5,
  HERETIC_S_BURNBALL1,
  HERETIC_S_BURNBALL2,
  HERETIC_S_BURNBALL3,
  HERETIC_S_BURNBALL4,
  HERETIC_S_BURNBALL5,
  HERETIC_S_BURNBALL6,
  HERETIC_S_BURNBALL7,
  HERETIC_S_BURNBALL8,
  HERETIC_S_BURNBALLFB1,
  HERETIC_S_BURNBALLFB2,
  HERETIC_S_BURNBALLFB3,
  HERETIC_S_BURNBALLFB4,
  HERETIC_S_BURNBALLFB5,
  HERETIC_S_BURNBALLFB6,
  HERETIC_S_BURNBALLFB7,
  HERETIC_S_BURNBALLFB8,
  HERETIC_S_PUFFY1,
  HERETIC_S_PUFFY2,
  HERETIC_S_PUFFY3,
  HERETIC_S_PUFFY4,
  HERETIC_S_PUFFY5,
  HERETIC_S_SNAKE_LOOK1,
  HERETIC_S_SNAKE_LOOK2,
  HERETIC_S_SNAKE_WALK1,
  HERETIC_S_SNAKE_WALK2,
  HERETIC_S_SNAKE_WALK3,
  HERETIC_S_SNAKE_WALK4,
  HERETIC_S_SNAKE_ATK1,
  HERETIC_S_SNAKE_ATK2,
  HERETIC_S_SNAKE_ATK3,
  HERETIC_S_SNAKE_ATK4,
  HERETIC_S_SNAKE_ATK5,
  HERETIC_S_SNAKE_ATK6,
  HERETIC_S_SNAKE_ATK7,
  HERETIC_S_SNAKE_ATK8,
  HERETIC_S_SNAKE_ATK9,
  HERETIC_S_SNAKE_PAIN1,
  HERETIC_S_SNAKE_PAIN2,
  HERETIC_S_SNAKE_DIE1,
  HERETIC_S_SNAKE_DIE2,
  HERETIC_S_SNAKE_DIE3,
  HERETIC_S_SNAKE_DIE4,
  HERETIC_S_SNAKE_DIE5,
  HERETIC_S_SNAKE_DIE6,
  HERETIC_S_SNAKE_DIE7,
  HERETIC_S_SNAKE_DIE8,
  HERETIC_S_SNAKE_DIE9,
  HERETIC_S_SNAKE_DIE10,
  HERETIC_S_SNAKEPRO_A1,
  HERETIC_S_SNAKEPRO_A2,
  HERETIC_S_SNAKEPRO_A3,
  HERETIC_S_SNAKEPRO_A4,
  HERETIC_S_SNAKEPRO_AX1,
  HERETIC_S_SNAKEPRO_AX2,
  HERETIC_S_SNAKEPRO_AX3,
  HERETIC_S_SNAKEPRO_AX4,
  HERETIC_S_SNAKEPRO_AX5,
  HERETIC_S_SNAKEPRO_B1,
  HERETIC_S_SNAKEPRO_B2,
  HERETIC_S_SNAKEPRO_BX1,
  HERETIC_S_SNAKEPRO_BX2,
  HERETIC_S_SNAKEPRO_BX3,
  HERETIC_S_SNAKEPRO_BX4,
  HERETIC_S_HEAD_LOOK,
  HERETIC_S_HEAD_FLOAT,
  HERETIC_S_HEAD_ATK1,
  HERETIC_S_HEAD_ATK2,
  HERETIC_S_HEAD_PAIN1,
  HERETIC_S_HEAD_PAIN2,
  HERETIC_S_HEAD_DIE1,
  HERETIC_S_HEAD_DIE2,
  HERETIC_S_HEAD_DIE3,
  HERETIC_S_HEAD_DIE4,
  HERETIC_S_HEAD_DIE5,
  HERETIC_S_HEAD_DIE6,
  HERETIC_S_HEAD_DIE7,
  HERETIC_S_HEADFX1_1,
  HERETIC_S_HEADFX1_2,
  HERETIC_S_HEADFX1_3,
  HERETIC_S_HEADFXI1_1,
  HERETIC_S_HEADFXI1_2,
  HERETIC_S_HEADFXI1_3,
  HERETIC_S_HEADFXI1_4,
  HERETIC_S_HEADFX2_1,
  HERETIC_S_HEADFX2_2,
  HERETIC_S_HEADFX2_3,
  HERETIC_S_HEADFXI2_1,
  HERETIC_S_HEADFXI2_2,
  HERETIC_S_HEADFXI2_3,
  HERETIC_S_HEADFXI2_4,
  HERETIC_S_HEADFX3_1,
  HERETIC_S_HEADFX3_2,
  HERETIC_S_HEADFX3_3,
  HERETIC_S_HEADFX3_4,
  HERETIC_S_HEADFX3_5,
  HERETIC_S_HEADFX3_6,
  HERETIC_S_HEADFXI3_1,
  HERETIC_S_HEADFXI3_2,
  HERETIC_S_HEADFXI3_3,
  HERETIC_S_HEADFXI3_4,
  HERETIC_S_HEADFX4_1,
  HERETIC_S_HEADFX4_2,
  HERETIC_S_HEADFX4_3,
  HERETIC_S_HEADFX4_4,
  HERETIC_S_HEADFX4_5,
  HERETIC_S_HEADFX4_6,
  HERETIC_S_HEADFX4_7,
  HERETIC_S_HEADFXI4_1,
  HERETIC_S_HEADFXI4_2,
  HERETIC_S_HEADFXI4_3,
  HERETIC_S_HEADFXI4_4,
  HERETIC_S_CLINK_LOOK1,
  HERETIC_S_CLINK_LOOK2,
  HERETIC_S_CLINK_WALK1,
  HERETIC_S_CLINK_WALK2,
  HERETIC_S_CLINK_WALK3,
  HERETIC_S_CLINK_WALK4,
  HERETIC_S_CLINK_ATK1,
  HERETIC_S_CLINK_ATK2,
  HERETIC_S_CLINK_ATK3,
  HERETIC_S_CLINK_PAIN1,
  HERETIC_S_CLINK_PAIN2,
  HERETIC_S_CLINK_DIE1,
  HERETIC_S_CLINK_DIE2,
  HERETIC_S_CLINK_DIE3,
  HERETIC_S_CLINK_DIE4,
  HERETIC_S_CLINK_DIE5,
  HERETIC_S_CLINK_DIE6,
  HERETIC_S_CLINK_DIE7,
  HERETIC_S_WIZARD_LOOK1,
  HERETIC_S_WIZARD_LOOK2,
  HERETIC_S_WIZARD_WALK1,
  HERETIC_S_WIZARD_WALK2,
  HERETIC_S_WIZARD_WALK3,
  HERETIC_S_WIZARD_WALK4,
  HERETIC_S_WIZARD_WALK5,
  HERETIC_S_WIZARD_WALK6,
  HERETIC_S_WIZARD_WALK7,
  HERETIC_S_WIZARD_WALK8,
  HERETIC_S_WIZARD_ATK1,
  HERETIC_S_WIZARD_ATK2,
  HERETIC_S_WIZARD_ATK3,
  HERETIC_S_WIZARD_ATK4,
  HERETIC_S_WIZARD_ATK5,
  HERETIC_S_WIZARD_ATK6,
  HERETIC_S_WIZARD_ATK7,
  HERETIC_S_WIZARD_ATK8,
  HERETIC_S_WIZARD_ATK9,
  HERETIC_S_WIZARD_PAIN1,
  HERETIC_S_WIZARD_PAIN2,
  HERETIC_S_WIZARD_DIE1,
  HERETIC_S_WIZARD_DIE2,
  HERETIC_S_WIZARD_DIE3,
  HERETIC_S_WIZARD_DIE4,
  HERETIC_S_WIZARD_DIE5,
  HERETIC_S_WIZARD_DIE6,
  HERETIC_S_WIZARD_DIE7,
  HERETIC_S_WIZARD_DIE8,
  HERETIC_S_WIZFX1_1,
  HERETIC_S_WIZFX1_2,
  HERETIC_S_WIZFXI1_1,
  HERETIC_S_WIZFXI1_2,
  HERETIC_S_WIZFXI1_3,
  HERETIC_S_WIZFXI1_4,
  HERETIC_S_WIZFXI1_5,
  HERETIC_S_IMP_LOOK1,
  HERETIC_S_IMP_LOOK2,
  HERETIC_S_IMP_LOOK3,
  HERETIC_S_IMP_LOOK4,
  HERETIC_S_IMP_FLY1,
  HERETIC_S_IMP_FLY2,
  HERETIC_S_IMP_FLY3,
  HERETIC_S_IMP_FLY4,
  HERETIC_S_IMP_FLY5,
  HERETIC_S_IMP_FLY6,
  HERETIC_S_IMP_FLY7,
  HERETIC_S_IMP_FLY8,
  HERETIC_S_IMP_MEATK1,
  HERETIC_S_IMP_MEATK2,
  HERETIC_S_IMP_MEATK3,
  HERETIC_S_IMP_MSATK1_1,
  HERETIC_S_IMP_MSATK1_2,
  HERETIC_S_IMP_MSATK1_3,
  HERETIC_S_IMP_MSATK1_4,
  HERETIC_S_IMP_MSATK1_5,
  HERETIC_S_IMP_MSATK1_6,
  HERETIC_S_IMP_MSATK2_1,
  HERETIC_S_IMP_MSATK2_2,
  HERETIC_S_IMP_MSATK2_3,
  HERETIC_S_IMP_PAIN1,
  HERETIC_S_IMP_PAIN2,
  HERETIC_S_IMP_DIE1,
  HERETIC_S_IMP_DIE2,
  HERETIC_S_IMP_XDIE1,
  HERETIC_S_IMP_XDIE2,
  HERETIC_S_IMP_XDIE3,
  HERETIC_S_IMP_XDIE4,
  HERETIC_S_IMP_XDIE5,
  HERETIC_S_IMP_CRASH1,
  HERETIC_S_IMP_CRASH2,
  HERETIC_S_IMP_CRASH3,
  HERETIC_S_IMP_CRASH4,
  HERETIC_S_IMP_XCRASH1,
  HERETIC_S_IMP_XCRASH2,
  HERETIC_S_IMP_XCRASH3,
  HERETIC_S_IMP_CHUNKA1,
  HERETIC_S_IMP_CHUNKA2,
  HERETIC_S_IMP_CHUNKA3,
  HERETIC_S_IMP_CHUNKB1,
  HERETIC_S_IMP_CHUNKB2,
  HERETIC_S_IMP_CHUNKB3,
  HERETIC_S_IMPFX1,
  HERETIC_S_IMPFX2,
  HERETIC_S_IMPFX3,
  HERETIC_S_IMPFXI1,
  HERETIC_S_IMPFXI2,
  HERETIC_S_IMPFXI3,
  HERETIC_S_IMPFXI4,
  HERETIC_S_KNIGHT_STND1,
  HERETIC_S_KNIGHT_STND2,
  HERETIC_S_KNIGHT_WALK1,
  HERETIC_S_KNIGHT_WALK2,
  HERETIC_S_KNIGHT_WALK3,
  HERETIC_S_KNIGHT_WALK4,
  HERETIC_S_KNIGHT_ATK1,
  HERETIC_S_KNIGHT_ATK2,
  HERETIC_S_KNIGHT_ATK3,
  HERETIC_S_KNIGHT_ATK4,
  HERETIC_S_KNIGHT_ATK5,
  HERETIC_S_KNIGHT_ATK6,
  HERETIC_S_KNIGHT_PAIN1,
  HERETIC_S_KNIGHT_PAIN2,
  HERETIC_S_KNIGHT_DIE1,
  HERETIC_S_KNIGHT_DIE2,
  HERETIC_S_KNIGHT_DIE3,
  HERETIC_S_KNIGHT_DIE4,
  HERETIC_S_KNIGHT_DIE5,
  HERETIC_S_KNIGHT_DIE6,
  HERETIC_S_KNIGHT_DIE7,
  HERETIC_S_SPINAXE1,
  HERETIC_S_SPINAXE2,
  HERETIC_S_SPINAXE3,
  HERETIC_S_SPINAXEX1,
  HERETIC_S_SPINAXEX2,
  HERETIC_S_SPINAXEX3,
  HERETIC_S_REDAXE1,
  HERETIC_S_REDAXE2,
  HERETIC_S_REDAXEX1,
  HERETIC_S_REDAXEX2,
  HERETIC_S_REDAXEX3,
  HERETIC_S_SRCR1_LOOK1,
  HERETIC_S_SRCR1_LOOK2,
  HERETIC_S_SRCR1_WALK1,
  HERETIC_S_SRCR1_WALK2,
  HERETIC_S_SRCR1_WALK3,
  HERETIC_S_SRCR1_WALK4,
  HERETIC_S_SRCR1_PAIN1,
  HERETIC_S_SRCR1_ATK1,
  HERETIC_S_SRCR1_ATK2,
  HERETIC_S_SRCR1_ATK3,
  HERETIC_S_SRCR1_ATK4,
  HERETIC_S_SRCR1_ATK5,
  HERETIC_S_SRCR1_ATK6,
  HERETIC_S_SRCR1_ATK7,
  HERETIC_S_SRCR1_DIE1,
  HERETIC_S_SRCR1_DIE2,
  HERETIC_S_SRCR1_DIE3,
  HERETIC_S_SRCR1_DIE4,
  HERETIC_S_SRCR1_DIE5,
  HERETIC_S_SRCR1_DIE6,
  HERETIC_S_SRCR1_DIE7,
  HERETIC_S_SRCR1_DIE8,
  HERETIC_S_SRCR1_DIE9,
  HERETIC_S_SRCR1_DIE10,
  HERETIC_S_SRCR1_DIE11,
  HERETIC_S_SRCR1_DIE12,
  HERETIC_S_SRCR1_DIE13,
  HERETIC_S_SRCR1_DIE14,
  HERETIC_S_SRCR1_DIE15,
  HERETIC_S_SRCR1_DIE16,
  HERETIC_S_SRCR1_DIE17,
  HERETIC_S_SRCRFX1_1,
  HERETIC_S_SRCRFX1_2,
  HERETIC_S_SRCRFX1_3,
  HERETIC_S_SRCRFXI1_1,
  HERETIC_S_SRCRFXI1_2,
  HERETIC_S_SRCRFXI1_3,
  HERETIC_S_SRCRFXI1_4,
  HERETIC_S_SRCRFXI1_5,
  HERETIC_S_SOR2_RISE1,
  HERETIC_S_SOR2_RISE2,
  HERETIC_S_SOR2_RISE3,
  HERETIC_S_SOR2_RISE4,
  HERETIC_S_SOR2_RISE5,
  HERETIC_S_SOR2_RISE6,
  HERETIC_S_SOR2_RISE7,
  HERETIC_S_SOR2_LOOK1,
  HERETIC_S_SOR2_LOOK2,
  HERETIC_S_SOR2_WALK1,
  HERETIC_S_SOR2_WALK2,
  HERETIC_S_SOR2_WALK3,
  HERETIC_S_SOR2_WALK4,
  HERETIC_S_SOR2_PAIN1,
  HERETIC_S_SOR2_PAIN2,
  HERETIC_S_SOR2_ATK1,
  HERETIC_S_SOR2_ATK2,
  HERETIC_S_SOR2_ATK3,
  HERETIC_S_SOR2_TELE1,
  HERETIC_S_SOR2_TELE2,
  HERETIC_S_SOR2_TELE3,
  HERETIC_S_SOR2_TELE4,
  HERETIC_S_SOR2_TELE5,
  HERETIC_S_SOR2_TELE6,
  HERETIC_S_SOR2_DIE1,
  HERETIC_S_SOR2_DIE2,
  HERETIC_S_SOR2_DIE3,
  HERETIC_S_SOR2_DIE4,
  HERETIC_S_SOR2_DIE5,
  HERETIC_S_SOR2_DIE6,
  HERETIC_S_SOR2_DIE7,
  HERETIC_S_SOR2_DIE8,
  HERETIC_S_SOR2_DIE9,
  HERETIC_S_SOR2_DIE10,
  HERETIC_S_SOR2_DIE11,
  HERETIC_S_SOR2_DIE12,
  HERETIC_S_SOR2_DIE13,
  HERETIC_S_SOR2_DIE14,
  HERETIC_S_SOR2_DIE15,
  HERETIC_S_SOR2FX1_1,
  HERETIC_S_SOR2FX1_2,
  HERETIC_S_SOR2FX1_3,
  HERETIC_S_SOR2FXI1_1,
  HERETIC_S_SOR2FXI1_2,
  HERETIC_S_SOR2FXI1_3,
  HERETIC_S_SOR2FXI1_4,
  HERETIC_S_SOR2FXI1_5,
  HERETIC_S_SOR2FXI1_6,
  HERETIC_S_SOR2FXSPARK1,
  HERETIC_S_SOR2FXSPARK2,
  HERETIC_S_SOR2FXSPARK3,
  HERETIC_S_SOR2FX2_1,
  HERETIC_S_SOR2FX2_2,
  HERETIC_S_SOR2FX2_3,
  HERETIC_S_SOR2FXI2_1,
  HERETIC_S_SOR2FXI2_2,
  HERETIC_S_SOR2FXI2_3,
  HERETIC_S_SOR2FXI2_4,
  HERETIC_S_SOR2FXI2_5,
  HERETIC_S_SOR2TELEFADE1,
  HERETIC_S_SOR2TELEFADE2,
  HERETIC_S_SOR2TELEFADE3,
  HERETIC_S_SOR2TELEFADE4,
  HERETIC_S_SOR2TELEFADE5,
  HERETIC_S_SOR2TELEFADE6,
  HERETIC_S_MNTR_LOOK1,
  HERETIC_S_MNTR_LOOK2,
  HERETIC_S_MNTR_WALK1,
  HERETIC_S_MNTR_WALK2,
  HERETIC_S_MNTR_WALK3,
  HERETIC_S_MNTR_WALK4,
  HERETIC_S_MNTR_ATK1_1,
  HERETIC_S_MNTR_ATK1_2,
  HERETIC_S_MNTR_ATK1_3,
  HERETIC_S_MNTR_ATK2_1,
  HERETIC_S_MNTR_ATK2_2,
  HERETIC_S_MNTR_ATK2_3,
  HERETIC_S_MNTR_ATK3_1,
  HERETIC_S_MNTR_ATK3_2,
  HERETIC_S_MNTR_ATK3_3,
  HERETIC_S_MNTR_ATK3_4,
  HERETIC_S_MNTR_ATK4_1,
  HERETIC_S_MNTR_PAIN1,
  HERETIC_S_MNTR_PAIN2,
  HERETIC_S_MNTR_DIE1,
  HERETIC_S_MNTR_DIE2,
  HERETIC_S_MNTR_DIE3,
  HERETIC_S_MNTR_DIE4,
  HERETIC_S_MNTR_DIE5,
  HERETIC_S_MNTR_DIE6,
  HERETIC_S_MNTR_DIE7,
  HERETIC_S_MNTR_DIE8,
  HERETIC_S_MNTR_DIE9,
  HERETIC_S_MNTR_DIE10,
  HERETIC_S_MNTR_DIE11,
  HERETIC_S_MNTR_DIE12,
  HERETIC_S_MNTR_DIE13,
  HERETIC_S_MNTR_DIE14,
  HERETIC_S_MNTR_DIE15,
  HERETIC_S_MNTRFX1_1,
  HERETIC_S_MNTRFX1_2,
  HERETIC_S_MNTRFXI1_1,
  HERETIC_S_MNTRFXI1_2,
  HERETIC_S_MNTRFXI1_3,
  HERETIC_S_MNTRFXI1_4,
  HERETIC_S_MNTRFXI1_5,
  HERETIC_S_MNTRFXI1_6,
  HERETIC_S_MNTRFX2_1,
  HERETIC_S_MNTRFXI2_1,
  HERETIC_S_MNTRFXI2_2,
  HERETIC_S_MNTRFXI2_3,
  HERETIC_S_MNTRFXI2_4,
  HERETIC_S_MNTRFXI2_5,
  HERETIC_S_MNTRFX3_1,
  HERETIC_S_MNTRFX3_2,
  HERETIC_S_MNTRFX3_3,
  HERETIC_S_MNTRFX3_4,
  HERETIC_S_MNTRFX3_5,
  HERETIC_S_MNTRFX3_6,
  HERETIC_S_MNTRFX3_7,
  HERETIC_S_MNTRFX3_8,
  HERETIC_S_MNTRFX3_9,
  HERETIC_S_AKYY1,
  HERETIC_S_AKYY2,
  HERETIC_S_AKYY3,
  HERETIC_S_AKYY4,
  HERETIC_S_AKYY5,
  HERETIC_S_AKYY6,
  HERETIC_S_AKYY7,
  HERETIC_S_AKYY8,
  HERETIC_S_AKYY9,
  HERETIC_S_AKYY10,
  HERETIC_S_BKYY1,
  HERETIC_S_BKYY2,
  HERETIC_S_BKYY3,
  HERETIC_S_BKYY4,
  HERETIC_S_BKYY5,
  HERETIC_S_BKYY6,
  HERETIC_S_BKYY7,
  HERETIC_S_BKYY8,
  HERETIC_S_BKYY9,
  HERETIC_S_BKYY10,
  HERETIC_S_CKYY1,
  HERETIC_S_CKYY2,
  HERETIC_S_CKYY3,
  HERETIC_S_CKYY4,
  HERETIC_S_CKYY5,
  HERETIC_S_CKYY6,
  HERETIC_S_CKYY7,
  HERETIC_S_CKYY8,
  HERETIC_S_CKYY9,
  HERETIC_S_AMG1,
  HERETIC_S_AMG2_1,
  HERETIC_S_AMG2_2,
  HERETIC_S_AMG2_3,
  HERETIC_S_AMM1,
  HERETIC_S_AMM2,
  HERETIC_S_AMC1,
  HERETIC_S_AMC2_1,
  HERETIC_S_AMC2_2,
  HERETIC_S_AMC2_3,
  HERETIC_S_AMS1_1,
  HERETIC_S_AMS1_2,
  HERETIC_S_AMS2_1,
  HERETIC_S_AMS2_2,
  HERETIC_S_AMP1_1,
  HERETIC_S_AMP1_2,
  HERETIC_S_AMP1_3,
  HERETIC_S_AMP2_1,
  HERETIC_S_AMP2_2,
  HERETIC_S_AMP2_3,
  HERETIC_S_AMB1_1,
  HERETIC_S_AMB1_2,
  HERETIC_S_AMB1_3,
  HERETIC_S_AMB2_1,
  HERETIC_S_AMB2_2,
  HERETIC_S_AMB2_3,
  HERETIC_S_SND_WIND,
  HERETIC_S_SND_WATERFALL,
  HERETIC_NUMSTATES
} statenum_t;

/********************************************************************
 * Definition of the state (frames) structure                       *
 ********************************************************************/

typedef struct
{
  spritenum_t sprite;       /* sprite number to show                       */
  long        frame;        /* which frame/subframe of the sprite is shown */
  long        tics;         /* number of gametics this frame should last   */
  actionf_t   action;       /* code pointer to function for action if any  */
  statenum_t  nextstate;    /* linked list pointer to next state or zero   */
  long        misc1, misc2; /* apparently never used in DOOM               */
  long        args[MAXSTATEARGS]; // [XA] mbf21 args
  int         flags;
} state_t;

// state flags
#define STATEF_SKILL5FAST 0x00000001 // tics halve on nightmare skill

/********************************************************************
 * Thing enumeration -- must match info.c                           *
 ********************************************************************
 * Note that many of these are generically named for the ornamentals
 */

typedef enum {
  MT_NULL = -1, // ferk: null/invalid mobj (zero is reserved for MT_PLAYER)
  MT_PLAYER,
  MT_POSSESSED,
  MT_SHOTGUY,
  MT_VILE,
  MT_FIRE,
  MT_UNDEAD,
  MT_TRACER,
  MT_SMOKE,
  MT_FATSO,
  MT_FATSHOT,
  MT_CHAINGUY,
  MT_TROOP,
  MT_SERGEANT,
  MT_SHADOWS,
  MT_HEAD,
  MT_BRUISER,
  MT_BRUISERSHOT,
  MT_KNIGHT,
  MT_SKULL,
  MT_SPIDER,
  MT_BABY,
  MT_CYBORG,
  MT_PAIN,
  MT_WOLFSS,
  MT_KEEN,
  MT_BOSSBRAIN,
  MT_BOSSSPIT,
  MT_BOSSTARGET,
  MT_SPAWNSHOT,
  MT_SPAWNFIRE,
  MT_BARREL,
  MT_TROOPSHOT,
  MT_HEADSHOT,
  MT_ROCKET,
  MT_PLASMA,
  MT_BFG,
  MT_ARACHPLAZ,
  MT_PUFF,
  MT_BLOOD,
  MT_TFOG,
  MT_IFOG,
  MT_TELEPORTMAN,
  MT_EXTRABFG,
  MT_MISC0,
  MT_MISC1,
  MT_MISC2,
  MT_MISC3,
  MT_MISC4,
  MT_MISC5,
  MT_MISC6,
  MT_MISC7,
  MT_MISC8,
  MT_MISC9,
  MT_MISC10,
  MT_MISC11,
  MT_MISC12,
  MT_INV,
  MT_MISC13,
  MT_INS,
  MT_MISC14,
  MT_MISC15,
  MT_MISC16,
  MT_MEGA,
  MT_CLIP,
  MT_MISC17,
  MT_MISC18,
  MT_MISC19,
  MT_MISC20,
  MT_MISC21,
  MT_MISC22,
  MT_MISC23,
  MT_MISC24,
  MT_MISC25,
  MT_CHAINGUN,
  MT_MISC26,
  MT_MISC27,
  MT_MISC28,
  MT_SHOTGUN,
  MT_SUPERSHOTGUN,
  MT_MISC29,
  MT_MISC30,
  MT_MISC31,
  MT_MISC32,
  MT_MISC33,
  MT_MISC34,
  MT_MISC35,
  MT_MISC36,
  MT_MISC37,
  MT_MISC38,
  MT_MISC39,
  MT_MISC40,
  MT_MISC41,
  MT_MISC42,
  MT_MISC43,
  MT_MISC44,
  MT_MISC45,
  MT_MISC46,
  MT_MISC47,
  MT_MISC48,
  MT_MISC49,
  MT_MISC50,
  MT_MISC51,
  MT_MISC52,
  MT_MISC53,
  MT_MISC54,
  MT_MISC55,
  MT_MISC56,
  MT_MISC57,
  MT_MISC58,
  MT_MISC59,
  MT_MISC60,
  MT_MISC61,
  MT_MISC62,
  MT_MISC63,
  MT_MISC64,
  MT_MISC65,
  MT_MISC66,
  MT_MISC67,
  MT_MISC68,
  MT_MISC69,
  MT_MISC70,
  MT_MISC71,
  MT_MISC72,
  MT_MISC73,
  MT_MISC74,
  MT_MISC75,
  MT_MISC76,
  MT_MISC77,
  MT_MISC78,
  MT_MISC79,
  MT_MISC80,
  MT_MISC81,
  MT_MISC82,
  MT_MISC83,
  MT_MISC84,
  MT_MISC85,
  MT_MISC86,
  MT_PUSH,    /* controls push source - phares */
  MT_PULL,    /* controls pull source - phares 3/20/98 */
  MT_DOGS,    /* killough 7/19/98: Marine's best friend */
  MT_PLASMA1, // killough 7/11/98: first  of alternating beta plasma fireballs
  MT_PLASMA2, // killough 7/11/98: second of alternating beta plasma fireballs
  MT_SCEPTRE, // killough 7/11/98: evil sceptre in beta version
  MT_BIBLE,   // killough 7/11/98: unholy bible in beta version

  MT_MUSICSOURCE, /* MUSINFO lump */
  MT_GIBDTH,

  /* proff 11/22/98: Andy Baker's stealth monsters (next 12)
   * cph - moved below the MBF stuff, no need to displace them */
  MT_STEALTHBABY,
  MT_STEALTHVILE,
  MT_STEALTHBRUISER,
  MT_STEALTHHEAD,
  MT_STEALTHCHAINGUY,
  MT_STEALTHSERGEANT,
  MT_STEALTHKNIGHT,
  MT_STEALTHIMP,
  MT_STEALTHFATSO,
  MT_STEALTHUNDEAD,
  MT_STEALTHSHOTGUY,
  MT_STEALTHZOMBIE,

  // 100 extra mobjs to use in dehacked patches
  MT_EXTRA00 = 150, MT_EXTRA01, MT_EXTRA02, MT_EXTRA03, MT_EXTRA04,
  MT_EXTRA05, MT_EXTRA06, MT_EXTRA07, MT_EXTRA08, MT_EXTRA09,
  MT_EXTRA10, MT_EXTRA11, MT_EXTRA12, MT_EXTRA13, MT_EXTRA14,
  MT_EXTRA15, MT_EXTRA16, MT_EXTRA17, MT_EXTRA18, MT_EXTRA19,
  MT_EXTRA20, MT_EXTRA21, MT_EXTRA22, MT_EXTRA23, MT_EXTRA24,
  MT_EXTRA25, MT_EXTRA26, MT_EXTRA27, MT_EXTRA28, MT_EXTRA29,
  MT_EXTRA30, MT_EXTRA31, MT_EXTRA32, MT_EXTRA33, MT_EXTRA34,
  MT_EXTRA35, MT_EXTRA36, MT_EXTRA37, MT_EXTRA38, MT_EXTRA39,
  MT_EXTRA40, MT_EXTRA41, MT_EXTRA42, MT_EXTRA43, MT_EXTRA44,
  MT_EXTRA45, MT_EXTRA46, MT_EXTRA47, MT_EXTRA48, MT_EXTRA49,
  MT_EXTRA50, MT_EXTRA51, MT_EXTRA52, MT_EXTRA53, MT_EXTRA54,
  MT_EXTRA55, MT_EXTRA56, MT_EXTRA57, MT_EXTRA58, MT_EXTRA59,
  MT_EXTRA60, MT_EXTRA61, MT_EXTRA62, MT_EXTRA63, MT_EXTRA64,
  MT_EXTRA65, MT_EXTRA66, MT_EXTRA67, MT_EXTRA68, MT_EXTRA69,
  MT_EXTRA70, MT_EXTRA71, MT_EXTRA72, MT_EXTRA73, MT_EXTRA74,
  MT_EXTRA75, MT_EXTRA76, MT_EXTRA77, MT_EXTRA78, MT_EXTRA79,
  MT_EXTRA80, MT_EXTRA81, MT_EXTRA82, MT_EXTRA83, MT_EXTRA84,
  MT_EXTRA85, MT_EXTRA86, MT_EXTRA87, MT_EXTRA88, MT_EXTRA89,
  MT_EXTRA90, MT_EXTRA91, MT_EXTRA92, MT_EXTRA93, MT_EXTRA94,
  MT_EXTRA95, MT_EXTRA96, MT_EXTRA97, MT_EXTRA98, MT_EXTRA99,

  NUMMOBJTYPES,  // Counter of how many there are

  // heretic
  HERETIC_MT_ZERO,
  HERETIC_MT_MISC0 = HERETIC_MT_ZERO,
  HERETIC_MT_ITEMSHIELD1,
  HERETIC_MT_ITEMSHIELD2,
  HERETIC_MT_MISC1,
  HERETIC_MT_MISC2,
  HERETIC_MT_ARTIINVISIBILITY,
  HERETIC_MT_MISC3,
  HERETIC_MT_ARTIFLY,
  HERETIC_MT_ARTIINVULNERABILITY,
  HERETIC_MT_ARTITOMEOFPOWER,
  HERETIC_MT_ARTIEGG,
  HERETIC_MT_EGGFX,
  HERETIC_MT_ARTISUPERHEAL,
  HERETIC_MT_MISC4,
  HERETIC_MT_MISC5,
  HERETIC_MT_FIREBOMB,
  HERETIC_MT_ARTITELEPORT,
  HERETIC_MT_POD,
  HERETIC_MT_PODGOO,
  HERETIC_MT_PODGENERATOR,
  HERETIC_MT_SPLASH,
  HERETIC_MT_SPLASHBASE,
  HERETIC_MT_LAVASPLASH,
  HERETIC_MT_LAVASMOKE,
  HERETIC_MT_SLUDGECHUNK,
  HERETIC_MT_SLUDGESPLASH,
  HERETIC_MT_SKULLHANG70,
  HERETIC_MT_SKULLHANG60,
  HERETIC_MT_SKULLHANG45,
  HERETIC_MT_SKULLHANG35,
  HERETIC_MT_CHANDELIER,
  HERETIC_MT_SERPTORCH,
  HERETIC_MT_SMALLPILLAR,
  HERETIC_MT_STALAGMITESMALL,
  HERETIC_MT_STALAGMITELARGE,
  HERETIC_MT_STALACTITESMALL,
  HERETIC_MT_STALACTITELARGE,
  HERETIC_MT_MISC6,
  HERETIC_MT_BARREL,
  HERETIC_MT_MISC7,
  HERETIC_MT_MISC8,
  HERETIC_MT_MISC9,
  HERETIC_MT_MISC10,
  HERETIC_MT_MISC11,
  HERETIC_MT_KEYGIZMOBLUE,
  HERETIC_MT_KEYGIZMOGREEN,
  HERETIC_MT_KEYGIZMOYELLOW,
  HERETIC_MT_KEYGIZMOFLOAT,
  HERETIC_MT_MISC12,
  HERETIC_MT_VOLCANOBLAST,
  HERETIC_MT_VOLCANOTBLAST,
  HERETIC_MT_TELEGLITGEN,
  HERETIC_MT_TELEGLITGEN2,
  HERETIC_MT_TELEGLITTER,
  HERETIC_MT_TELEGLITTER2,
  HERETIC_MT_TFOG,
  HERETIC_MT_TELEPORTMAN,
  HERETIC_MT_STAFFPUFF,
  HERETIC_MT_STAFFPUFF2,
  HERETIC_MT_BEAKPUFF,
  HERETIC_MT_MISC13,
  HERETIC_MT_GAUNTLETPUFF1,
  HERETIC_MT_GAUNTLETPUFF2,
  HERETIC_MT_MISC14,
  HERETIC_MT_BLASTERFX1,
  HERETIC_MT_BLASTERSMOKE,
  HERETIC_MT_RIPPER,
  HERETIC_MT_BLASTERPUFF1,
  HERETIC_MT_BLASTERPUFF2,
  HERETIC_MT_WMACE,
  HERETIC_MT_MACEFX1,
  HERETIC_MT_MACEFX2,
  HERETIC_MT_MACEFX3,
  HERETIC_MT_MACEFX4,
  HERETIC_MT_WSKULLROD,
  HERETIC_MT_HORNRODFX1,
  HERETIC_MT_HORNRODFX2,
  HERETIC_MT_RAINPLR1,
  HERETIC_MT_RAINPLR2,
  HERETIC_MT_RAINPLR3,
  HERETIC_MT_RAINPLR4,
  HERETIC_MT_GOLDWANDFX1,
  HERETIC_MT_GOLDWANDFX2,
  HERETIC_MT_GOLDWANDPUFF1,
  HERETIC_MT_GOLDWANDPUFF2,
  HERETIC_MT_WPHOENIXROD,
  HERETIC_MT_PHOENIXFX1,
  HERETIC_MT_PHOENIXFX_REMOVED,  // In Heretic 1.0, but removed.
  HERETIC_MT_PHOENIXPUFF,
  HERETIC_MT_PHOENIXFX2,
  HERETIC_MT_MISC15,
  HERETIC_MT_CRBOWFX1,
  HERETIC_MT_CRBOWFX2,
  HERETIC_MT_CRBOWFX3,
  HERETIC_MT_CRBOWFX4,
  HERETIC_MT_BLOOD,
  HERETIC_MT_BLOODSPLATTER,
  HERETIC_MT_PLAYER,
  HERETIC_MT_BLOODYSKULL,
  HERETIC_MT_CHICPLAYER,
  HERETIC_MT_CHICKEN,
  HERETIC_MT_FEATHER,
  HERETIC_MT_MUMMY,
  HERETIC_MT_MUMMYLEADER,
  HERETIC_MT_MUMMYGHOST,
  HERETIC_MT_MUMMYLEADERGHOST,
  HERETIC_MT_MUMMYSOUL,
  HERETIC_MT_MUMMYFX1,
  HERETIC_MT_BEAST,
  HERETIC_MT_BEASTBALL,
  HERETIC_MT_BURNBALL,
  HERETIC_MT_BURNBALLFB,
  HERETIC_MT_PUFFY,
  HERETIC_MT_SNAKE,
  HERETIC_MT_SNAKEPRO_A,
  HERETIC_MT_SNAKEPRO_B,
  HERETIC_MT_HEAD,
  HERETIC_MT_HEADFX1,
  HERETIC_MT_HEADFX2,
  HERETIC_MT_HEADFX3,
  HERETIC_MT_WHIRLWIND,
  HERETIC_MT_CLINK,
  HERETIC_MT_WIZARD,
  HERETIC_MT_WIZFX1,
  HERETIC_MT_IMP,
  HERETIC_MT_IMPLEADER,
  HERETIC_MT_IMPCHUNK1,
  HERETIC_MT_IMPCHUNK2,
  HERETIC_MT_IMPBALL,
  HERETIC_MT_KNIGHT,
  HERETIC_MT_KNIGHTGHOST,
  HERETIC_MT_KNIGHTAXE,
  HERETIC_MT_REDAXE,
  HERETIC_MT_SORCERER1,
  HERETIC_MT_SRCRFX1,
  HERETIC_MT_SORCERER2,
  HERETIC_MT_SOR2FX1,
  HERETIC_MT_SOR2FXSPARK,
  HERETIC_MT_SOR2FX2,
  HERETIC_MT_SOR2TELEFADE,
  HERETIC_MT_MINOTAUR,
  HERETIC_MT_MNTRFX1,
  HERETIC_MT_MNTRFX2,
  HERETIC_MT_MNTRFX3,
  HERETIC_MT_AKYY,
  HERETIC_MT_BKYY,
  HERETIC_MT_CKEY,
  HERETIC_MT_AMGWNDWIMPY,
  HERETIC_MT_AMGWNDHEFTY,
  HERETIC_MT_AMMACEWIMPY,
  HERETIC_MT_AMMACEHEFTY,
  HERETIC_MT_AMCBOWWIMPY,
  HERETIC_MT_AMCBOWHEFTY,
  HERETIC_MT_AMSKRDWIMPY,
  HERETIC_MT_AMSKRDHEFTY,
  HERETIC_MT_AMPHRDWIMPY,
  HERETIC_MT_AMPHRDHEFTY,
  HERETIC_MT_AMBLSRWIMPY,
  HERETIC_MT_AMBLSRHEFTY,
  HERETIC_MT_SOUNDWIND,
  HERETIC_MT_SOUNDWATERFALL,
  HERETIC_NUMMOBJTYPES,

  TOTAL_NUMMOBJTYPES = HERETIC_NUMMOBJTYPES
} mobjtype_t;

typedef enum {
  IG_DEFAULT,
  IG_END
} infighting_group_t;

typedef enum {
  PG_GROUPLESS = -1,
  PG_DEFAULT,
  PG_BARON,
  PG_END
} projectile_group_t;

typedef enum {
  SG_DEFAULT,
  SG_END
} splash_group_t;

/********************************************************************
 * Definition of the Thing structure
 ********************************************************************/
/* Note that these are only indices to the state, sound, etc. arrays
 * and not actual pointers.  Most can be set to zero if the action or
 * sound doesn't apply (like lamps generally don't attack or whistle).
 */

typedef struct
{
  int doomednum;    /* Thing number used in id's editor, and now
       probably by every other editor too */
  int spawnstate;   /* The state (frame) index when this Thing is
           first created */
  int spawnhealth;  /* The initial hit points for this Thing */
  int seestate;     /* The state when it sees you or wakes up */
  int seesound;     /* The sound it makes when waking */
  int reactiontime; /* How many tics it waits after it wakes up
           before it will start to attack, in normal
           skills (halved for nightmare) */
  int attacksound;  /* The sound it makes when it attacks */
  int painstate;    /* The state to indicate pain */
  int painchance;   /* A number that is checked against a random
           number 0-255 to see if the Thing is supposed
           to go to its painstate or not.  Note this
           has absolutely nothing to do with the chance
           it will get hurt, just the chance of it
           reacting visibly. */
  int painsound;    /* The sound it emits when it feels pain */
  int meleestate;   /* Melee==close attack */
  int missilestate; /* What states to use when it's in the air, if
           in fact it is ever used as a missile */
  int deathstate;   /* What state begins the death sequence */
  int xdeathstate;  /* What state begins the horrible death sequence
           like when a rocket takes out a trooper */
  int deathsound;   /* The death sound.  See also A_Scream() in
           p_enemy.c for some tweaking that goes on
           for certain monsters */
  int speed;        /* How fast it moves.  Too fast and it can miss
           collision logic. */
  int radius;       /* An often incorrect radius */
  int height;       /* An often incorrect height, used only to see
           if a monster can enter a sector */
  int mass;         /* How much an impact will move it.  Cacodemons
           seem to retreat when shot because they have
           very little mass and are moved by impact */
  int damage;       /* If this is a missile, how much does it hurt? */
  int activesound;  /* What sound it makes wandering around, once
           in a while.  Chance is 3/256 it will. */
  uint_64_t flags;  /* Bit masks for lots of things.  See p_mobj.h */

  // not in heretic
  int raisestate;   /* The first state for an Archvile or respawn
           resurrection.  Zero means it won't come
           back to life. */
  mobjtype_t droppeditem; /* ferk: Mobj to drop after death */

  // heretic
  int crashstate;
  uint_64_t flags2;

  // mbf21
  int infighting_group;
  int projectile_group;
  int splash_group;
  int ripsound;
  int altspeed;
  int meleerange;
} mobjinfo_t;

#define NO_ALTSPEED -1

typedef struct
{
    int doomednum;
    int spawnstate;
    int spawnhealth;
    int seestate;
    int seesound;
    int reactiontime;
    int attacksound;
    int painstate;
    int painchance;
    int painsound;
    int meleestate;
    int missilestate;
    int deathstate;
    int xdeathstate;
    int deathsound;
    int speed;
    int radius;
    int height;
    int mass;
    int damage;
    int activesound;
    uint_64_t flags;
    int raisestate;
    mobjtype_t droppeditem;
} doom_mobjinfo_t;

typedef struct
{
    int doomednum;
    int spawnstate;
    int spawnhealth;
    int seestate;
    int seesound;
    int reactiontime;
    int attacksound;
    int painstate;
    int painchance;
    int painsound;
    int meleestate;
    int missilestate;
    int crashstate;
    int deathstate;
    int xdeathstate;
    int deathsound;
    int speed;
    int radius;
    int height;
    int mass;
    int damage;
    int activesound;
    int flags;
    int flags2;
} heretic_mobjinfo_t;

// all the stuff - dynamically selected in global.c

extern state_t heretic_states[HERETIC_NUMSTATES];
extern const char *heretic_sprnames[];
extern heretic_mobjinfo_t heretic_mobjinfo[HERETIC_NUMMOBJTYPES];

extern state_t doom_states[NUMSTATES];
extern const char *doom_sprnames[];
extern doom_mobjinfo_t doom_mobjinfo[NUMMOBJTYPES];

extern state_t* states;
extern int num_states;
extern const char** sprnames;
extern int num_sprites;
extern mobjinfo_t* mobjinfo;
extern int num_mobj_types;
extern int mobj_types_zero;
extern int mobj_types_max;

#endif
